on beginSprite(me)
  if ShowDirect then
    drawCar(me, me.spriteNum)
  end if
  exit
end

on new(me, theUseChassisLoc)
  useChassisLoc = theUseChassisLoc
  return(me)
  exit
end

on drawCar(me, theStartSP, theOffset, theParts, thePercentage)
  chassisSP = gMulleGlobals.user.car.chassisSPOffset
  if voidp(theStartSP) then
    theStartSP = me.spriteNum
  end if
  if useChassisLoc then
    offsetH = sprite(theStartSP + chassisSP).locH
    offsetV = sprite(theStartSP + chassisSP).locV
    theOffset = point(offsetH, offsetV)
  end if
  if voidp(theOffset) then
    theOffset = point(offsetH, offsetV)
  end if
  if voidp(theParts) then
    tempCar = gMulleGlobals.user.car
    parts = getParts(tempCar)
  else
    tempCar = new(script("Car"))
    objectList = [#parts:theParts, #medals:[], #name:"", #cacheList:[]]
    fromList(tempCar, objectList)
    parts = theParts
  end if
  mulleLayer = gMulleGlobals.user.car.driverLayer
  x = 1
  repeat while x <= count(parts)
    partToMount = getPart(gMulleGlobals.parts, getAt(parts, x))
    tempSnaps = getRequiredPoints(partToMount)
    if listp(tempSnaps) then
      firstSnapPoint = getAt(tempSnaps, 1)
      useLayers = getSnapInfo(tempCar, firstSnapPoint, #layers)
      snapOffset = duplicate(getSnapInfo(tempCar, firstSnapPoint, #offset))
    else
      useLayers = [chassisSP]
      snapOffset = point(0, 0)
    end if
    tempSP = getAt(useLayers, 1)
    if tempSP > mulleLayer - 1 then
      tempSP = tempSP + 2
    end if
    setSpriteThings(me, theStartSP + tempSP, partToMount, theOffset, snapOffset, thePercentage, 1)
    if count(useLayers) = 2 then
      tempSP = getAt(useLayers, 2)
      if tempSP > -1 then
        if tempSP > mulleLayer - 1 then
          tempSP = tempSP + 2
        end if
        setSpriteThings(me, theStartSP + getAt(useLayers, 2), partToMount, theOffset, snapOffset, thePercentage, 2)
      end if
    end if
    x = 1 + x
  end repeat
  if the movieName.char[1..2] = "03" then
    freeOrBindParts(gDir.partsCommon)
  end if
  exit
end

on setSpriteThings(me, theSP, partToMount, theOffset, theSnapOffset, thePercentage, theNr)
  if theNr = 1 then
    tempMember = getUseView(partToMount)
  else
    tempMember = getUseView2(partToMount)
    if length(tempMember) = 0 then
      exit
    end if
  end if
  sprite(theSP).name = tempMember
  partOffset = duplicate(getOffset(partToMount))
  if not voidp(thePercentage) then
    setAt(partOffset, 1, integer(getAt(partOffset, 1) * thePercentage))
    setAt(partOffset, 2, integer(getAt(partOffset, 2) * thePercentage))
    setAt(theSnapOffset, 1, integer(getAt(theSnapOffset, 1) * thePercentage))
    setAt(theSnapOffset, 2, integer(getAt(theSnapOffset, 2) * thePercentage))
    sprite(theSP).width = integer(member(tempMember).width * thePercentage)
    sprite(theSP).height = integer(member(tempMember).height * thePercentage)
  end if
  sprite(theSP).position = theOffset + partOffset + theSnapOffset
  sendSprite(theSP, #setPart, getId(partToMount))
  exit
end

on getPropertyDescriptionList(me)
  p_list = [#ShowDirect:[#comment:"Show car directly:", #format:#boolean, #default:1], #useChassisLoc:[#comment:"Use chassis loc as midpoint: ", #format:#boolean, #default:1], #offsetH:[#comment:"If not, use these:  LocH:", #format:#integer, #range:[#min:-200, #max:840], #default:320], #offsetV:[#comment:"LocV:", #format:#integer, #range:[#min:-200, #max:680], #default:240]]
  return(p_list)
  exit
end

on getBehaviorDescription(me)
  return("Draw Mulles car. Set this behaviour to the first of 35 sprites reserved for the car")
  exit
end