on new(me)
  missionList = []
  kickMission = 0
  loopState = 0
  return(me)
  exit
end

on kill(me)
  missionList = 0
  return(0)
  exit
end

on loop(me)
  if getType(currentMission) = #Telephone then
    if loopState = #Shake then
      frameCount = frameCount + 1
      if finished(gSound, currentSound) = 0 then
        if frameCount mod 2 = 0 then
          sprite(phoneSmallSP).position = point(getAt(sprite(phoneSmallSP).position, 1) - 2, getAt(sprite(phoneSmallSP).position, 2))
          updateStage()
        else
          sprite(phoneSmallSP).position = point(getAt(sprite(phoneSmallSP).position, 1) + 2, getAt(sprite(phoneSmallSP).position, 2))
          updateStage()
        end if
      else
        finishPhone(me)
        deleteLoopObject(gDir, me)
      end if
    else
      if loopState = #Talk then
        if finished(gSound, currentSound) = 1 then
          loopState = ""
          deleteLoopObject(gDir, me)
          hangUp(me)
        end if
      end if
    end if
  else
    if finished(gSound, currentSound) = 0 then
      nothing()
    else
      if the mouseDown then
        finishMail(me)
        deleteLoopObject(gDir, me)
      end if
    end if
  end if
  exit
end

on checkMissions(me)
  if gMulleGlobals.user.nrOfBuiltCars mod 2 = 0 and gMulleGlobals.user.missionIsComing = 1 and gMulleGlobals.user.nrOfBuiltCars > 0 then
    if objectp(currentMission) = 0 then
      tmpDoneList = gMulleGlobals.user.givenMissions
      tmpToDoList = missionList
      tmpGiven = gMulleGlobals.user.completedMissions
      put("tmpgiven ", tmpGiven)
      if count(tmpDoneList) > 0 then
        n = 1
        repeat while n <= count(tmpDoneList)
          deleteOne(tmpToDoList, getAt(tmpDoneList, n))
          n = 1 + n
        end repeat
      end if
      put("tmpToDoList after 1 ", tmpToDoList)
      if count(tmpToDoList) > 0 then
        kickMission = getAt(tmpToDoList, 1)
        loadMission(me, kickMission)
      end if
    end if
  end if
  exit
end

on performMission(me)
  activate(gDir, 0)
  gMulleGlobals.user.missionIsComing = 0
  if getType(currentMission) = #Telephone then
    kickTelephone(me)
  else
    if getType(currentMission) = #Mail then
      kickMail(me)
    end if
  end if
  exit
end

on kickTelephone(me)
  phoneSmallSP = getaProp(gDir.spriteList, #TeleSmall)
  phoneBigSP = getaProp(gDir.spriteList, #TeleBig)
  tmpLoc = sprite(phoneSmallSP).position
  currentSound = play(gSound, "03e001v0", #EFFECT)
  frameCount = 0
  loopState = #Shake
  addLoopObject(gDir, me)
  exit
end

on finishPhone(me)
  sprite(phoneSmallSP).position = tmpLoc
  sprite(phoneBigSP).name = "03b002v0"
  sprite(phoneBigSP).position = point(320, 240)
  updateStage()
  currentSound = play(gSound, getSound(currentMission), #EFFECT)
  loopState = #Talk
  addLoopObject(gDir, me)
  exit
end

on hangUp(me)
  sprite(phoneBigSP).name = "Dummy"
  updateStage()
  add(gMulleGlobals.user.givenMissions, kickMission)
  gMulleGlobals.user.missionIsComing = 0
  currentMission = kill(currentMission)
  kickMission = 0
  activate(gDir, 1)
  exit
end

on kickMail(me)
  add(gMulleGlobals.user.givenMissions, kickMission)
  gMulleGlobals.user.missionIsComing = 0
  sprite(getProp(gDir.spriteList, #addresNote)).name = getimage(currentMission)
  sprite(getaProp(gDir.spriteList, #addresNote)).position = point(320, 240)
  updateStage()
  currentSound = play(gSound, getSound(currentMission), #EFFECT)
  addLoopObject(gDir, me)
  exit
end

on finishMail(me)
  sprite(getProp(gDir.spriteList, #addresNote)).name = "dummy"
  sprite(getProp(gDir.spriteList, #mailBox)).name = "04n001v0"
  updateStage()
  currentMission = kill(currentMission)
  kickMission = 0
  activate(gDir, 1)
  exit
end

on toList(me)
  return(missionList)
  exit
end

on fromList(me, objectList)
  missionList = objectList
  put("missionList", missionList)
  exit
end

on loadMission(me, MissionId)
  currentMission = new(script("mission"))
  fromList(currentMission, MissionId)
  exit
end