on new(me)
  parts = []
  enterParts = []
  name = ""
  medals = []
  carSnapOffsets = []
  carProperties = [#Weight:0, #break:0, #Durability:0, #Grip:0, #Steering:0, #acceleration:0, #speed:0, #Strength:0, #FuelConsumption:0, #FuelVolume:0, #ElectricConsumption:0, #ElectricVolume:0, #Comfort:0, #FunnyFactor:0, #Horn:0, #ExhaustPipe:0, #Lamps:0, #LoadCapacity:0, #EngineType:0, #HornType:0, #Pedals:0]
  cacheList = []
  carSnapPoints = []
  chassisSPOffset = 7
  driverLayer = 18
  newCarName = member("00t002v0").text
  return(me)
  exit
end

on kill(me)
  parts = 0
  medals = 0
  carProperties = 0
  cacheList = 0
  return(0)
  exit
end

on getCacheProp(me, theProp)
  temp = getaProp(cacheList, theProp)
  if voidp(temp) then
    return(#NoProp)
  else
    return(temp)
  end if
  exit
end

on setCacheProp(me, theProp, optionalData)
  if voidp(optionalData) then
    optionalData = 0
  end if
  if voidp(getaProp(cacheList, theProp)) then
    addProp(cacheList, theProp, optionalData)
  else
    setProp(cacheList, theProp, optionalData)
  end if
  exit
end

on deleteCacheProp(me, theProp)
  deleteProp(cacheList, theProp)
  exit
end

on areTheseFree(me, theList)
  if count(theList) = 0 then
    return(0)
  end if
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    if getPos(carSnapPoints, index) = 0 then
      return(0)
    end if
  end repeat
  -- UNK_65 3
  return(1)
  exit
end

on deletePart(me, partId)
  foundIt = getPos(parts, partId)
  if foundIt then
    deleteAt(parts, foundIt)
  else
    alert("NOT FOUND!")
  end if
  exit
end

on rebuild(me)
  tempParts = duplicate(parts)
  parts = []
  carSnapPoints = []
  carSnapOffsets = []
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    part = getAt()
    addPart(me, part)
  end repeat
  -- UNK_65 3
  exit
end

on findPart(me, partId)
  part = getPart(gMulleGlobals.parts, partId)
  if not objectp(part) then
    return(0)
  end if
  morphs = getMorphList(part)
  if not listp(morphs) then
    morphs = [partId]
  end if
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    if getPos(parts, index) then
      return(1)
    end if
  end repeat
  -- UNK_65 3
  return(0)
  exit
end

on clearCar(me)
  cacheList = []
  name = newCarName
  medals = []
  exit
end

on trash(me)
  chassis = gMulleGlobals.chassis
  n = 1
  repeat while n <= count(parts)
    partId = getAt(parts, n)
    tempPart = getPart(gMulleGlobals.parts, partId)
    tempMaster = getMaster(tempPart)
    if integerp(tempMaster) then
      if tempMaster > 0 then
        partId = tempMaster
      end if
    end if
    if partId <> chassis then
      addJunkPart(gMulleGlobals.user, #RandomPile, partId)
    end if
    n = 1 + n
  end repeat
  parts = []
  carSnapOffsets = []
  carProperties = [#Weight:0, #break:0, #Durability:0, #Grip:0, #Steering:0, #acceleration:0, #speed:0, #Strength:0, #FuelConsumption:0, #FuelVolume:0, #ElectricConsumption:0, #ElectricVolume:0, #Comfort:0, #FunnyFactor:0, #Horn:0, #ExhaustPipe:0, #Lamps:0, #LoadCapacity:0, #EngineType:0, #HornType:0, #Pedals:0]
  carSnapPoints = []
  clearCar(me)
  addPart(me, gMulleGlobals.chassis)
  exit
end

on addMedal(me, newMedalId)
  if getPos(medals, newMedalId) = 0 then
    add(medals, newMedalId)
  end if
  exit
end

on getMedal(me, medalId)
  if getPos(medals, medalId) then
    return(1)
  end if
  return(0)
  exit
end

on getSnapInfo(me, snapPoint, what)
  if what = #layers then
    return(getAt(getaProp(carSnapOffsets, snapPoint), 1))
  else
    if what = #offset then
      return(getAt(getaProp(carSnapOffsets, snapPoint), 2))
    end if
  end if
  return(getaProp(carSnapOffsets, snapPoint))
  exit
end

on addPart(me, newPartId)
  add(parts, newPartId)
  part = getPart(gMulleGlobals.parts, newPartId)
  if not objectp(part) then
    stop()
  end if
  coversPoints = getCoveredPoints(part)
  if listp(coversPoints) then
    -- UNK_64 0
    -- UNK_64 0
    -- UNK_64 2
    repeat while ERROR <= ERROR
      -- UNK_64 2
      -- UNK_64 1
      index = getAt()
      deleteOne(carSnapPoints, index)
    end repeat
    -- UNK_65 3
  end if
  newPoints = getNewPoints(part)
  if listp(newPoints) then
    -- UNK_64 0
    -- UNK_64 0
    -- UNK_64 2
    repeat while ERROR <= ERROR
      -- UNK_64 2
      -- UNK_64 1
      index = getAt()
      tempSnap = getAt(index, 1)
      add(carSnapPoints, tempSnap)
      tempLayers = getAt(index, 2)
      tempOffset = getAt(index, 3)
      addProp(carSnapOffsets, tempSnap, [tempLayers, tempOffset])
    end repeat
    -- UNK_65 3
  end if
  exit
end

on removePart(me, partId)
  foundIt = getPos(parts, partId)
  if foundIt then
    deleteAt(parts, foundIt)
    part = getPart(gMulleGlobals.parts, partId)
    coversPoints = getCoveredPoints(part)
    if listp(coversPoints) then
      -- UNK_64 0
      -- UNK_64 0
      -- UNK_64 2
      repeat while ERROR <= ERROR
        -- UNK_64 2
        -- UNK_64 1
        index = getAt()
        add(carSnapPoints, index)
      end repeat
      -- UNK_65 3
    end if
    newPoints = getNewPoints(part)
    if listp(newPoints) then
      -- UNK_64 0
      -- UNK_64 0
      -- UNK_64 2
      repeat while ERROR <= ERROR
        -- UNK_64 2
        -- UNK_64 1
        index = getAt()
        tempSnap = getAt(index, 1)
        deleteOne(carSnapPoints, tempSnap)
        deleteProp(carSnapOffsets, tempSnap)
      end repeat
      -- UNK_65 3
    end if
  end if
  exit
end

on getParts(me)
  return(parts)
  exit
end

on setName(me, NewName)
  name = NewName
  exit
end

on getName(me)
  return(name)
  exit
end

on updateProperties(me)
  carProperties = [#Weight:0, #break:0, #Durability:0, #Grip:0, #Steering:0, #acceleration:0, #speed:0, #Strength:0, #FuelConsumption:0, #FuelVolume:0, #ElectricConsumption:0, #ElectricVolume:0, #Comfort:0, #FunnyFactor:0, #Horn:0, #ExhaustPipe:0, #Lamps:0, #Pedals:0, #LoadCapacity:0, #EngineType:0, #HornType:0]
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    partId = getAt()
    part = getPart(gMulleGlobals.parts, partId)
    setProp(carProperties, #Weight, getaProp(carProperties, #Weight) + getProperty(part, #Weight))
    setProp(carProperties, #break, getaProp(carProperties, #break) + getProperty(part, #break))
    tempDur = getProperty(part, #Durability)
    if integerp(tempDur) then
      if tempDur < getaProp(carProperties, #Durability) or tempDur <> 0 and getaProp(carProperties, #Durability) = 0 then
        setProp(carProperties, #Durability, getProperty(part, #Durability))
      end if
    end if
    setProp(carProperties, #Grip, getaProp(carProperties, #Grip) + getProperty(part, #Grip))
    if getProperty(part, #Steering) > getaProp(carProperties, #Steering) then
      setProp(carProperties, #Steering, getProperty(part, #Steering))
    end if
    if getProperty(part, #acceleration) > getaProp(carProperties, #acceleration) then
      setProp(carProperties, #acceleration, getProperty(part, #acceleration))
    end if
    if getProperty(part, #speed) > getaProp(carProperties, #speed) then
      setProp(carProperties, #speed, getProperty(part, #speed))
    end if
    setProp(carProperties, #Strength, getaProp(carProperties, #Strength) + getProperty(part, #Strength))
    setProp(carProperties, #FuelConsumption, getaProp(carProperties, #FuelConsumption) + getProperty(part, #FuelConsumption))
    setProp(carProperties, #FuelVolume, getaProp(carProperties, #FuelVolume) + getProperty(part, #FuelVolume))
    setProp(carProperties, #ElectricConsumption, getaProp(carProperties, #ElectricConsumption) + getProperty(part, #ElectricConsumption))
    setProp(carProperties, #ElectricVolume, getaProp(carProperties, #ElectricVolume) + getProperty(part, #ElectricVolume))
    setProp(carProperties, #Comfort, getaProp(carProperties, #Comfort) + getProperty(part, #Comfort))
    setProp(carProperties, #FunnyFactor, getaProp(carProperties, #FunnyFactor) + getProperty(part, #FunnyFactor))
    if getProperty(part, #Horn) then
      setProp(carProperties, #Horn, 1)
    end if
    if getProperty(part, #ExhaustPipe) then
      setProp(carProperties, #ExhaustPipe, 1)
    end if
    if getProperty(part, #Lamps) then
      setProp(carProperties, #Lamps, 1)
    end if
    if getProperty(part, #Pedals) then
      setProp(carProperties, #Pedals, 1)
    end if
    setProp(carProperties, #LoadCapacity, getaProp(carProperties, #LoadCapacity) + getProperty(part, #LoadCapacity))
    if getProperty(part, #EngineType) > getaProp(carProperties, #EngineType) then
      setProp(carProperties, #EngineType, getProperty(part, #EngineType))
    end if
    if getProperty(part, #HornType) > getaProp(carProperties, #HornType) then
      setProp(carProperties, #HornType, getProperty(part, #HornType))
    end if
  end repeat
  -- UNK_65 3
  exit
end

on getProperty(me, prop)
  return(getaProp(carProperties, prop))
  exit
end

on toList(me)
  return([#parts:parts, #name:name, #medals:medals, #cacheList:cacheList])
  exit
end

on fromList(me, objectList)
  tempParts = getaProp(objectList, #parts)
  name = getaProp(objectList, #name)
  medals = getaProp(objectList, #medals)
  cacheList = getaProp(objectList, #cacheList)
  parts = []
  carSnapOffsets = []
  carSnapPoints = []
  if count(tempParts) = 0 then
    tempParts = [gMulleGlobals.chassis]
  else
    if getAt(tempParts, 1) = 0 then
      tempParts = [gMulleGlobals.chassis]
    end if
  end if
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    part = getAt()
    addPart(me, part)
  end repeat
  -- UNK_65 3
  exit
end