on beginSprite(me)
  type = #SpriteAnim
  if voidp(Active) then
    Active = 1
    init(me)
  else
    if Active then
      init(me)
    end if
  end if
  exit
end

on endSprite(me)
  if sndId then
    stop(gSound, sndId)
  end if
  exit
end

on activate(me, YesNo)
  Active = YesNo
  exit
end

on init(me)
  if not object = #Custom then
    frameListMember = string(object)
  end if
  myLoc = sprite(me.spriteNum).position
  if movement = #Custom then
    if customMovement.char[1] = "#" then
      -- UNK_86 924
    end if
    movement = symbol(customMovement)
  end if
  setAnimFirstFrame(me, firstFrame)
  waitState = #move
  setAnimChart(me, frameListMember)
  if length(toLoc) > 0 then
    toLocStr = toLoc
    toLoc = value(toLoc)
    if not listp(toLoc) then
      tempOff = offset(",", toLocStr)
      if tempOff then
        tempX = value(toLocStr.char[1..tempOff - 1])
        tempY = value(toLocStr.char[tempOff + 1..length(toLocStr)])
        toLoc = point(tempX, tempY)
      end if
    else
      toLoc = point(getAt(toLoc, 1), getAt(toLoc, 2))
    end if
  end if
  setAnimPath(me, movePathName, toLoc, nrOfSteps)
  playAnimSound(me, soundMember)
  exitFrame(me)
  exit
end

on setAnimChart(me, theName)
  tempChart = value(member(theName & "AnimChart").text)
  allFrameLists = getaProp(tempChart, #Actions)
  allPathLists = getaProp(tempChart, #Paths)
  setAnimAction(me, movement)
  sprite(me.spriteNum).name = member(firstFrame + getAt(FrameList, 1) - 1)
  exit
end

on setAnimFirstFrame(me, theMember)
  if firstFrame = "" then
    firstFrame = sprite(0).number
  else
    firstFrame = sprite(0).number
  end if
  exit
end

on playAnimSound(me, theSnd)
  if length(theSnd) > 0 then
    stop(gSound, sndId)
    sndId = play(gSound, theSnd, #EFFECT)
    myChannel = getChannel(gSound, sndId)
  else
    stop(gSound, sndId)
    sndId = 0
    myChannel = 0
  end if
  exit
end

on makeAnimSpeech(me, theSnd)
  repeatIt = 1
  syncTalk = 1
  playAnimSound(me, theSnd)
  waitForWhat = #sound
  exit
end

on setAnimNormal(me)
  repeatIt = 0
  syncTalk = 0
  waitForWhat = #Anim
  doWhat = #SendSpriteMe
  exit
end

on getAnimAction(me)
  return(movement)
  exit
end

on getAnimWaitState(me)
  return(waitState)
  exit
end

on setAnimAction(me, theMove)
  if theMove = #Still then
    playAnimSound(me, "")
  end if
  movement = theMove
  if theMove = #wait then
    options = getaProp(allFrameLists, #wait)
    if waitState = #move then
      tempFrameList = [getAt(options, 1)]
      waitState = #Still
    else
      theMove = getAt(options, random(count(options) - 1) + 1)
      tempFrameList = getaProp(allFrameLists, theMove)
      waitState = #move
    end if
  else
    tempFrameList = getaProp(allFrameLists, theMove)
  end if
  FrameList = []
  soundList = []
  n = 1
  repeat while n <= count(tempFrameList)
    index = getAt(tempFrameList, n)
    if listp(index) then
      -- UNK_64 0
      if ERROR = #RndHold then
        holdFrame = getAt(index, 2)
        minVal = getAt(index, 3)
        maxVal = getAt(index, 4)
        tempRnd = minVal + random(maxVal - minVal)
        x = 1
        repeat while x <= tempRnd
          add(FrameList, holdFrame)
          add(soundList, 0)
          x = 1 + x
        end repeat
        exit repeat
      end if
      -- UNK_64 0
      if ERROR = #RndFrame then
        rndList = getAt(index, 2)
        add(FrameList, getAt(rndList, random(count(rndList))))
        add(soundList, 0)
      else
        -- UNK_64 0
        if ERROR = #sound then
          rndList = getAt(index, 2)
          tempSnd = getAt(rndList, random(count(rndList)))
          if stringp(tempSnd) then
            add(soundList, tempSnd)
          else
            add(soundList, 0)
          end if
        end if
      end if
      -- UNK_65 1
    else
      add(FrameList, index)
      add(soundList, 0)
    end if
    n = 1 + n
  end repeat
  if waitForWhat = #Anim and not doWhat = #SendSpriteMe and not movement = #wait then
    add(FrameList, 1)
    add(soundList, 0)
  end if
  listLen = count(FrameList)
  actionCounter = 0
  actionActive = 1
  exit
end

on setAnimPath(me, movePathName, toLoc, nrOfSteps)
  pathActive = 0
  pathCounter = 0
  if length(movePathName) then
    movePath = getaProp(allPathLists, symbol(movePathName))
    nrOfSteps = count(movePath)
    if pathRelative then
      n = 1
      repeat while n <= count(movePath)
        setAt(movePath, n, getAt(movePath, n) + myLoc)
        n = 1 + n
      end repeat
    end if
    pathActive = 1
  else
    if listp(toLoc) then
      movePath = []
      if pathRelative then
        diff = toLoc
      else
        diff = toLoc - myLoc
      end if
      nrOfSteps = value(nrOfSteps)
      if nrOfSteps = 0 then
        nrOfSteps = 1
      end if
      step = diff / nrOfSteps
      n = 1
      repeat while n <= nrOfSteps
        add(movePath, myLoc + step * n)
        n = 1 + n
      end repeat
      pathActive = 1
    end if
  end if
  exit
end

on spritecuePassed(me, theChannel, cueNr, cueName)
  if syncTalk then
    if myChannel = theChannel then
      if not finished(gSound, sndId) then
        if cueName = "Talk" then
          setAnimAction(me, #Talk)
        else
          if cueName = "Silence" then
            waitState = #move
            setAnimAction(me, #wait)
          end if
        end if
      end if
    end if
  end if
  exit
end

on exitFrame(me)
  if Active then
    if pathActive then
      pathCounter = pathCounter + 1
      myLoc = getAt(movePath, pathCounter)
      if pathCounter >= nrOfSteps then
        pathActive = 0
        if waitForWhat = #path then
          doTheWhat(me)
          exit
        end if
      end if
    end if
    sprite(me.spriteNum).position = myLoc
    if actionActive then
      actionCounter = actionCounter + 1
      if autoSound then
        tempSound = getAt(soundList, actionCounter)
        if stringp(tempSound) then
          stop(gSound, opSndId)
          opSndId = play(gSound, tempSound, #OPEFFECT)
        end if
      end if
      tempFrame = getAt(FrameList, actionCounter)
      sprite(me.spriteNum).name = member(firstFrame + tempFrame - 1)
      if actionCounter >= listLen then
        if repeatIt or movement = #wait then
          setAnimAction(me, movement)
        else
          if movement = #Still then
            actionCounter = 0
          else
            actionActive = 0
            if waitForWhat = #Anim then
              doTheWhat(me)
            end if
          end if
        end if
      end if
    end if
    if sndId and waitForWhat = #sound then
      if finished(gSound, sndId) then
        doTheWhat(me)
      end if
    end if
  end if
  exit
end

on setAnimLoc(me, theLoc, isRelational)
  if isRelational then
    myLoc = myLoc + theLoc
  else
    tempPos = getPos(theLoc, -4711)
    if tempPos then
      setAt(theLoc, tempPos, getAt(myLoc, tempPos))
    end if
    myLoc = theLoc
  end if
  exit
end

on doTheWhat(me)
  -- UNK_64 0
  if ERROR = #GoNextFrame then
    go(the frame + 1)
  else
    -- UNK_64 0
    if ERROR = #GoNextMarker then
      go(#next)
    else
      -- UNK_64 0
      if ERROR = #SendSpriteMe then
        sendSprite(me.spriteNum, #Stopped)
      end if
    end if
  end if
  -- UNK_65 1
  exit
end

on getPropertyDescriptionList(me)
  p_list = [#object:[#comment:"Predefined object:", #format:#symbol, #range:[#standard, #Mulle, #Buffa, #Custom], #default:#standard], #frameListMember:[#comment:"If #Custom, define frameChart member:", #format:#string, #default:""], #movement:[#comment:"Object's action:", #format:#symbol, #range:[#Still, #Talk, #wait, #TalkWait, #Scratch, #Custom], #default:#Still], #customMovement:[#comment:"If #Custom, define action:", #format:#string, #default:""], #firstFrame:[#comment:"and first frame (if not defined, use shown member):", #format:#string, #default:""], #repeatIt:[#comment:"Repeat action:", #format:#boolean, #default:0], #soundMember:[#comment:"Sound (member name):", #format:#string, #default:""], #syncTalk:[#comment:"Sync sound and talk:", #format:#boolean, #default:0], #autoSound:[#comment:"Play auto sounds:", #format:#boolean, #default:1], #waitForWhat:[#comment:"Wait for:", #format:#symbol, #range:[#none, #sound, #Anim, #path], #default:#none], #doWhat:[#comment:"then", #format:#symbol, #range:[#GoNextFrame, #GoNextMarker, #SendSpriteMe], #default:#GoNextFrame], #movePathName:[#comment:"Move along path:", #format:#string, #default:""], #toLoc:[#comment:"Or to loc (point(x,y)):", #format:#string, #default:""], #nrOfSteps:[#comment:"Nr of steps:", #format:#integer, #default:0], #pathRelative:[#comment:"Relative path:", #format:#boolean, #default:1], #Active:[#comment:"Active:", #format:#boolean, #default:1]]
  return(p_list)
  exit
end