on newMember(newMemberType, newMemberName, newMemberLib)
  newMember = new(newMemberType, castLib(newMemberLib))
  newMember.name = newMemberName
  exit
end

on copyMember(fromMember, newMemberName, newMemberLib)
  newMember = new(fromMember.type, castLib(newMemberLib))
  newMember.name = newMemberName
  newMember.media = fromMember.media
  newMember.name = newMemberName
  if newMember.number = -1 then
    return(0)
  end if
  if not newMember.name = newMemberName then
    return(0)
  end if
  return(1)
  exit
end

on copyMemberList(fromMemberList, newMemberLib)
  lastMemberNum = the number of castMembers
  n = 1
  repeat while n <= count(fromMemberList)
    fromMember = getAt(fromMemberList, n)
    newMember = new(fromMember.type, member(lastMemberNum + n, newMemberLib))
    newMember.name = fromMember.name
    newMember.media = fromMember.media
    n = 1 + n
  end repeat
  exit
end

on copyMembers(startMemberNum, endMemberNum, fromCastLib, toCastLib)
  membersXferred = []
  membersToErase = []
  lastMemberNum = the number of castMembers
  n = 1
  repeat while n <= endMemberNum - startMemberNum + 1
    if the freeBlock < 300 * 1024 then
      save(castLib(toCastLib))
      unloadMember()
    end if
    fromMember = member(n + startMemberNum - 1, fromCastLib)
    if not member(fromMember).type = #empty then
      if not sprite(toCastLib).number = -1 then
        add(membersToErase, member(fromMember.name, toCastLib))
      end if
      newMember = new(1, member(toCastLib + the number of castMembers, toCastLib))
      put(fromMember.name)
      newMember.name = fromMember.name
      newMember.media = fromMember.media
      if newMember.size < fromMember.size / 2 then
        put(newMember.size, fromMember.size)
        alert("Out of memory! Plugin transfer cancelled.")
        -- UNK_64 0
        -- UNK_64 0
        -- UNK_64 2
        repeat while ERROR <= ERROR
          -- UNK_64 2
          -- UNK_64 1
          index = getAt()
          erase(index)
        end repeat
        -- UNK_65 3
        return(0)
      end if
      add(membersXferred, newMember)
    end if
    n = 1 + n
  end repeat
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    erase(index)
  end repeat
  -- UNK_65 3
  return(1)
  exit
end

on checkForPlugins()
  castsToXfer = []
  dirFiles = []
  n = 1
  repeat while n <= the maxinteger
    tempFile = getNthFileNameInFolder(gPathGlobals.pluginPath, n)
    tempLen = length(tempFile)
    if tempLen = 0 then
    else
      if tempFile.char[tempLen - 3..tempLen] = ".cst" or tempFile.char[tempLen - 3..tempLen] = ".cxt" then
        add(castsToXfer, tempFile)
      else
        if tempFile.char[tempLen - 3..tempLen] = ".dxr" then
          add(dirFiles, tempFile)
        end if
      end if
    end if
    n = 1 + n
  end repeat
  return([#cast:castsToXfer, #Dir:dirFiles])
  exit
end

on xferPluginCasts(theCastName)
  tempCast = "TempPlug"
  toCast = "data"
  castLib(tempCast).fileName = gPathGlobals.pluginPath & theCastName
  if the number of castMembers > 0 then
    plugMain = ["PartsDB", "WorldsDB", "MapsDB", "ObjectsDB", "MissionsDB", "ExternalPartsDB"]
    nrOfMembers = the number of castMembers
    startMember = count(plugMain) + 1
    wasOK = copyMembers(startMember, nrOfMembers, tempCast, toCast)
    if wasOK then
      n = 1
      repeat while n <= count(plugMain)
        if sprite(tempCast).number <> -1 then
          toList = value(member(getAt(plugMain, n), toCast).text)
          fromList = value(member(getAt(plugMain, n), tempCast).text)
          if listp(toList) and listp(fromList) then
            if getAt(plugMain, n) = "ExternalPartsDB" then
              m = 1
              repeat while m <= count(fromList)
                tempPlugProp = getPropAt(fromList, m)
                if not voidp(getaProp(toList, tempPlugProp)) then
                  tempToList = getAt(toList, m)
                  tempFromList = getAt(fromList, m)
                  -- UNK_64 0
                  -- UNK_64 0
                  -- UNK_64 2
                  repeat while ERROR <= ERROR
                    -- UNK_64 2
                    -- UNK_64 1
                    tempPart = getAt()
                    add(tempToList, tempPart)
                  end repeat
                  -- UNK_65 3
                  setProp(toList, tempPlugProp, tempToList)
                end if
                m = 1 + m
              end repeat
              member(getAt(plugMain, n), toCast).text = string(toList)
            else
              if count(fromList) then
                -- UNK_64 0
                -- UNK_64 0
                -- UNK_64 2
                repeat while ERROR <= ERROR
                  -- UNK_64 2
                  -- UNK_64 1
                  index = getAt()
                  if not getPos(toList, index) then
                    add(toList, index)
                  end if
                end repeat
                -- UNK_65 3
                member(getAt(plugMain, n), toCast).text = string(toList)
              end if
            end if
          end if
        end if
        n = 1 + n
      end repeat
      castLib(tempCast).fileName = gPathGlobals.CDPath & "tempPlug"
      tempFile = new(xtra("FileIO"))
      openFile(tempFile, gPathGlobals.pluginPath & theCastName, 1)
      delete(tempFile)
      closeFile(tempFile)
      tempFile = 0
      save(castLib(toCast))
      unloadMember()
    end if
  end if
  castLib(tempCast).fileName = gPathGlobals.CDPath & "tempPlug"
  exit
end