on new(me)
  channels = [1:0, 2:0, 3:0]
  channelInfo = [[], [], []]
  newSnd = 1
  if the machineType = 256 then
    ticksPerSec = 63
  else
    ticksPerSec = 60
  end if
  return(me)
  exit
end

on kill(me)
  nothing()
  exit
end

on finished(me, sndId)
  purge(me)
  if sndId <> 0 then
    if getProp(channels, 2) = sndId then
      return(0)
    else
      if getProp(channels, 1) = sndId then
        return(0)
      else
        if getProp(channels, 3) = sndId then
          return(0)
        else
          return(1)
        end if
      end if
    end if
  else
    return(1)
  end if
  exit
end

on getChannel(me, sndId)
  purge(me)
  n = 1
  repeat while n <= count(channels)
    if getAt(channels, n) = sndId then
      return(value(getPropAt(channels, n)))
    end if
    n = 1 + n
  end repeat
  return(0)
  exit
end

on fade(me, sndId, inOut, theLength)
  if sndId <> 0 then
    tempCh = 0
    if getProp(channels, 2) = sndId then
      tempCh = 2
    else
      if getProp(channels, 1) = sndId then
        tempCh = 1
      else
        if getProp(channels, 3) = sndId then
          tempCh = 3
        end if
      end if
    end if
    if tempCh then
      if inOut = #in then
        sound(#fadeIn, tempCh, theLength)
      else
        sound(#fadeOut, tempCh, theLength)
      end if
    end if
  end if
  exit
end

on stop(me, sndId)
  if sndId <> 0 then
    if getProp(channels, 2) = sndId then
      sound(#stop, 2)
      setProp(channels, 2, 0)
    else
      if getProp(channels, 1) = sndId then
        sound(#stop, 1)
        setProp(channels, 1, 0)
      else
        if getProp(channels, 3) = sndId then
          sound(#stop, 3)
          setProp(channels, 3, 0)
        end if
      end if
    end if
  end if
  return(0)
  exit
end

on stopBG(me)
  if getProp(channels, 1) <> 0 then
    sound(#stop, 1)
    setProp(channels, 1, 0)
  end if
  exit
end

on stopAllEffects(me)
  if getProp(channels, 2) <> 0 then
    sound(#stop, 2)
    setProp(channels, 2, 0)
  end if
  if getProp(channels, 3) <> 0 then
    sound(#stop, 3)
    setProp(channels, 3, 0)
  end if
  exit
end

on play(me, soundMember, what, theOption)
  purge(me)
  if voidp(theOption) then
    theOption = #member
    if sprite(0).number = -1 or soundMember = "" then
      put("Snd: ", soundMember)
      soundMember = "20d163v0"
    end if
  end if
  -- UNK_64 0
  if ERROR = #BG then
    newSnd = newSnd + 1
    setProp(channels, 1, newSnd)
    lowLevelPlay(me, 1, theOption, soundMember)
    return(newSnd)
  else
    -- UNK_64 0
    if ERROR = #TRANS then
      newSnd = newSnd + 1
      setProp(channels, 1, newSnd)
      stopAllEffects(me)
      lowLevelPlay(me, 1, theOption, soundMember)
      return(newSnd)
    else
      -- UNK_64 0
      if ERROR = #EFFECT then
        if getProp(channels, 3) = 0 then
          newSnd = newSnd + 1
          setProp(channels, 3, newSnd)
          lowLevelPlay(me, 3, theOption, soundMember)
          return(newSnd)
        else
          newSnd = newSnd + 1
          setProp(channels, 2, newSnd)
          lowLevelPlay(me, 2, theOption, soundMember)
          return(newSnd)
        end if
      else
        -- UNK_64 0
        if ERROR = #OPEFFECT then
          if getProp(channels, 2) = 0 then
            newSnd = newSnd + 1
            setProp(channels, 2, newSnd)
            lowLevelPlay(me, 2, theOption, soundMember)
            return(newSnd)
          else
            if getProp(channels, 3) = 0 then
              newSnd = newSnd + 1
              setProp(channels, 3, newSnd)
              lowLevelPlay(me, 3, theOption, soundMember)
              return(newSnd)
            end if
          end if
        end if
      end if
    end if
  end if
  -- UNK_65 1
  return(0)
  exit
end

on lowLevelPlay(me, ch, how, theName)
  if how = #file then
    sound(#playFile, ch, theName)
    if the result <> 0 then
      put("Snd", theName)
      puppetSound(ch, "20d163v0")
      setAt(channelInfo, ch, [#member, the ticks, 0])
    else
      setAt(channelInfo, ch, [#file])
    end if
  else
    if how = #member then
      puppetSound(ch, theName)
      setAt(channelInfo, ch, [#member, the ticks, member(theName).loop, 90 + member(theName).size * ticksPerSec / 11025])
    end if
  end if
  exit
end

on purge(me)
  if not soundBusy(1) then
    setProp(channels, 1, 0)
  end if
  if not soundBusy(2) then
    setProp(channels, 2, 0)
  else
    tempInfo = getAt(channelInfo, 2)
    if count(tempInfo) then
      if getAt(tempInfo, 1) = #member then
        if the ticks - getAt(tempInfo, 2) > getAt(tempInfo, 4) and getAt(tempInfo, 3) = 0 then
          setProp(channels, 2, 0)
          sound(#stop, 2)
        end if
      end if
    end if
  end if
  if not soundBusy(3) then
    setProp(channels, 3, 0)
  else
    tempInfo = getAt(channelInfo, 3)
    if count(tempInfo) then
      if getAt(tempInfo, 1) = #member then
        if the ticks - getAt(tempInfo, 2) > getAt(tempInfo, 4) and getAt(tempInfo, 3) = 0 then
          setProp(channels, 3, 0)
          sound(#stop, 3)
        end if
      end if
    end if
  end if
  exit
end

on cuePassed(me, theChannel, theNumber, theName)
  theChannel = value(the last char in string(theChannel))
  sendAllSprites(#spritecuePassed, theChannel, theNumber, theName)
  exit
end