on beginSprite(me)
  Active = 1
  if partId <> 0 then
    update(me)
    tracking = 0
  end if
  exit
end

on activate(me, theState)
  Active = theState
  exit
end

on setPart(me, newPart)
  partId = getAt(newPart, 1)
  position = getAt(newPart, 2)
  if partId <> 0 then
    part = getPart(gMulleGlobals.parts, partId)
  end if
  update(me)
  exit
end

on update(me)
  if partId <> 0 then
    sprite(the currentSpriteNum).undefined = member(getJunkView(part))
    sprite(the currentSpriteNum).undefined = position
  end if
  exit
end

on mouseDown(me)
  if Active and partId <> 0 then
    sendSprite(120, #grabPart, partId, the currentSpriteNum)
  end if
  exit
end

on PlayDescription(me)
  tmpSound = getaProp(part, #description)
  sendSprite(getaProp(gDir.spriteList, #Mulle), #describepart, tmpSound)
  exit
end

on moveToShop(me, currentPile)
  if getaProp(gMulleGlobals.junkPileHandlers.maxParts, #shopFloor) <= count(getaProp(getaProp(gMulleGlobals.user, #junk), #shopFloor)) then
    sendSprite(120, #flowBack)
    sendSprite(120, #putOnTop, the currentSpriteNum)
    sendSprite(getaProp(gDir.spriteList, #Mulle), #MakeMulleSpeak, #shopFull)
  else
    tmpPileName = symbol("pile" & currentPile)
    removeJunkPart(gMulleGlobals.user, tmpPileName, partId)
    addJunkPart(gMulleGlobals.user, #shopFloor, partId)
    gDir.partsInShop = gDir.partsInShop + 1
    kickPartSound(gMulleGlobals.SharedSound, 0, partId, #ExternalGround)
  end if
  exit
end

on moveToDifferentPile(me, fromPile, toPile)
  if getaProp(gMulleGlobals.junkPileHandlers.maxParts, symbol("pile" & toPile)) <= count(getaProp(getaProp(gMulleGlobals.user, #junk), symbol("pile" & toPile)) + 1) then
    put("alllright")
    sendSprite(120, #flowBack)
    sendSprite(getaProp(gDir.spriteList, #Mulle), #MakeMulleSpeak, #pileFull)
  else
    kickPartSound(gMulleGlobals.SharedSound, the currentSpriteNum, partId, #ExternalGround)
    removeJunkPart(gMulleGlobals.user, symbol("pile" & fromPile), partId)
    addJunkPart(gMulleGlobals.user, symbol("pile" & toPile), partId)
    sendSprite(120, #checkNrofParts)
  end if
  exit
end

on getPropertyDescriptionList(me)
  return([#partId:[#comment:"Which part (partId 0-999):", #format:#integer, #default:0], #position:[#comment:"Which position", #format:#point, #default:point(0, 0)]])
  exit
end