on beginSprite(me)
  dialogActive = 0
  sndDelay = 10
  counter = 0
  myMember = "19b001v0"
  SP = me.spriteNum
  steerSP = SP + 1
  myLoc = point(320, 200)
  sprite(SP).undefined = myLoc
  sprite(steerSP).undefined = myLoc
  rectList = [#Steering:rect(116, 114, 197, 244), #Home:rect(216, 116, 281, 249), #Diploma:rect(316, 127, 368, 264), #quit:rect(390, 125, 460, 266), #Cancel:rect(470, 255, 528, 365)]
  soundList = [#Home:"09d006v0", #Cancel:"09d004v0", #Steering:"09d005v0", #quit:"09d003v0", #Diploma:"09d002v0"]
  diff = myLoc - point(320, 240)
  if not diff = point(0, 0) then
    diff = rect(getAt(diff, 1), getAt(diff, 2), getAt(diff, 1), getAt(diff, 2))
    n = 1
    repeat while n <= count(rectList)
      setAt(rectList, n, getAt(rectList, n) + diff)
      n = 1 + n
    end repeat
  end if
  exit
end

on startMeUp(me)
  sprite(SP).undefined = member(myMember)
  activate(gDir, 0)
  dialogActive = 1
  currentCursor = #standard
  steerMode(me, #show)
  sendSprite(115, #MEnter, "c_standard", 2)
  exit
end

on closeMeDown(me)
  sprite(SP).undefined = member("Dummy")
  sprite(steerSP).undefined = member("Dummy")
  activate(gDir, 1)
  dialogActive = 0
  sendSprite(115, #MLeave, 2)
  sendSprite(115, #MLeave)
  stop(gSound, sndId)
  exit
end

on exitFrame(me)
  if dialogActive then
    if wasShowing then
      activate(gDir, 0)
      wasShowing = 0
    end if
    if counter then
      counter = counter - 1
      if counter = 0 then
        stop(gSound, sndId)
        sndId = play(gSound, getProp(soundList, oldType), #EFFECT)
      end if
    end if
    isInside = 0
    x = 1
    repeat while x <= count(rectList)
      if inside(point(the mouseH, the mouseV), getAt(rectList, x)) then
        isInside = 1
        sendSprite(115, #MEnter, "c_click")
        cursorNumber = x
        tempType = getPropAt(rectList, x)
        currentCursor = #click
        if not oldType = tempType then
          hasBeenOutside = 0
          stop(gSound, sndId)
          counter = sndDelay
          oldType = tempType
        else
          if finished(gSound, sndId) and counter = 0 and hasBeenOutside then
            hasBeenOutside = 0
            counter = sndDelay
            oldType = tempType
          end if
        end if
      else
        x = 1 + x
      end if
    end repeat
    if not isInside then
      if finished(gSound, sndId) then
        hasBeenOutside = 1
        oldType = 0
      end if
      counter = 0
      sendSprite(115, #MLeave)
      currentCursor = #standard
    end if
  end if
  exit
end

on steerMode(me, theMode)
  if objectp(gDir.carDriving) then
    tempSteer = gDir.carDriving.keySteer
    if theMode = #Change then
      tempSteer = not tempSteer
      setKeySteer(gDir, tempSteer)
    end if
    if tempSteer then
      sprite(steerSP).undefined = member("Dummy")
    else
      sprite(steerSP).undefined = member("09b005v0")
    end if
  end if
  exit
end

on mouseUp(me)
  exitFrame(me)
  if currentCursor = #click then
    play(gSound, "SndMouseClick", #OPEFFECT)
    -- UNK_64 0
    if ERROR = 1 then
      steerMode(me, #Change)
    else
      -- UNK_64 0
      if ERROR = 2 then
        prepareToLeave(gDir, "03")
      else
        -- UNK_64 0
        if ERROR = 3 then
          prepareToLeave(gDir, "08")
        else
          -- UNK_64 0
          if ERROR = 4 then
            go(1, "12")
          else
            -- UNK_64 0
            if ERROR = 5 then
              functionDialogSwitch(me)
            end if
          end if
        end if
      end if
    end if
    -- UNK_65 1
  end if
  exit
end

on functionDialogSwitch(me)
  if dialogActive then
    closeMeDown(me)
  else
    wasShowing = 0
    if gDir.mode = #Showing then
      sendSprite(getProp(gDir.spriteList, #ShowOff), #mouseUp)
      wasShowing = 1
    end if
    startMeUp(me)
  end if
  exit
end