on new(me)
  speed = 0
  direction = 0
  fuel = 0
  coordinate = point(0, 0)
  lastCoordinate = point(0, 0)
  userSteer = 1
  internalDirection = 0
  waitForTurn = 0
  Steering = 0
  lastMouseLoc = point(0, 0)
  nrOfDirections = 16
  decimalPrec = 100
  stopTimer = 0
  Topology = ""
  directionList = []
  reachForSpeed = 0
  reachForDirection = 0
  keySteer = 1
  forwardBackward = 0
  altitude = 0
  inclination = 0
  frameCount = 0
  shouldCheckGround = 1
  mouseForward = 1
  cursorDirection = 1
  previousData = []
  n = 1
  repeat while n <= 10
    temp = []
    add(temp, point(0, 0))
    add(temp, 1)
    add(temp, 0)
    add(previousData, duplicate(temp))
    n = 1 + n
  end repeat
  thisHit = 0
  directionLock = 0
  inTerrain = 0
  pi = pi()
  n = 1
  repeat while n <= nrOfDirections
    tempAngle = pi() * 2 * n / float(nrOfDirections)
    xPart = integer(decimalPrec * sin(tempAngle))
    yPart = -integer(decimalPrec * cos(tempAngle))
    add(directionList, point(xPart, yPart))
    n = 1 + n
  end repeat
  return(me)
  exit
end

on convertCarProps(me)
  gotElectricEngine = 0
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    partId = getAt()
    part = getPart(gMulleGlobals.parts, partId)
    if getProperty(part, #ElectricConsumption) > 0 then
      gotElectricEngine = 1
    else
    end if
  end repeat
  -- UNK_65 3
  if gotElectricEngine then
    if getaProp(quickCarProps, #ElectricConsumption) < 0 then
      setProp(quickCarProps, #ElectricConsumption, 0)
    end if
  else
    setProp(quickCarProps, #ElectricVolume, 0)
  end if
  if getaProp(quickCarProps, #FuelConsumption) = 0 then
    setProp(quickCarProps, #FuelVolume, 0)
  end if
  if getaProp(quickCarProps, #speed) = 5 then
    setProp(quickCarProps, #speed, getaProp(quickCarProps, #speed) * decimalPrec * 27 / 10)
  else
    setProp(quickCarProps, #speed, getaProp(quickCarProps, #speed) * decimalPrec * 20 / 10)
  end if
  setProp(quickCarProps, #break, getaProp(quickCarProps, #break) * decimalPrec * 3 / 10)
  setProp(quickCarProps, #acceleration, getaProp(quickCarProps, #acceleration) * decimalPrec * 2 / 10)
  setProp(quickCarProps, #Steering, getaProp(quickCarProps, #Steering) + 3 * decimalPrec * 2 / 20)
  setProp(quickCarProps, #FuelVolume, getaProp(quickCarProps, #FuelVolume) * decimalPrec * 12)
  setProp(quickCarProps, #ElectricVolume, getaProp(quickCarProps, #ElectricVolume) * decimalPrec * 15)
  maxAcc = getaProp(quickCarProps, #break)
  if maxAcc < getaProp(quickCarProps, #acceleration) then
    maxAcc = getaProp(quickCarProps, #acceleration)
  end if
  setEngine(displayObject)
  exit
end

on kill(me)
  displayObject = kill(displayObject)
  return(0)
  exit
end

on init(me, theWorld)
  displayObject = new(script("DisplayCar"), me, #show)
  start(me, theWorld)
  exit
end

on start(me, theWorld)
  speed = 0
  Steering = 0
  coordinate = decimalPrec * point(290, 280)
  direction = 4
  internalDirection = decimalPrec * direction
  quickCarProps = [#break:3, #Grip:8, #Steering:4, #acceleration:4, #speed:3, #FuelConsumption:3, #FuelVolume:3, #ElectricConsumption:2, #ElectricVolume:5, #Strength:5, #Durability:4, #HornType:5, #EngineType:getProperty(gMulleGlobals.user.car, #EngineType), #Pedals:0]
  if not getProp(quickCarProps, #EngineType) > 0 then
    setProp(quickCarProps, #EngineType, 3)
  end if
  convertCarProps(me)
  exit
end

on getCoordinate(me)
  return(coordinate / decimalPrec)
  exit
end

on setCoordinate(me, theCoord, theOption)
  coordinate = theCoord * decimalPrec
  if theOption = #AdjustTopo then
    coordinate = coordinate + point(0, 3) * altitude * decimalPrec
  end if
  exit
end

on getShowCoordinate(me)
  return(coordinate / decimalPrec - point(0, 3) * altitude)
  exit
end

on getInclination(me)
  return(inclination)
  exit
end

on getSpeed(me)
  return(speed / decimalPrec)
  exit
end

on getDirection(me)
  return(direction)
  exit
end

on show(me, YesNo)
  show(displayObject, YesNo)
  exit
end

on steer(me, theDirection)
  if directionLock then
    exit
  end if
  Steering = theDirection
  reachForDirection = 0
  exit
end

on lockDirection(me, YesNo)
  directionLock = YesNo
  Steering = 0
  exit
end

on changeSpeed(me, upDown)
  acceleration = upDown
  reachForSpeed = 0
  exit
end

on getFuel(me)
  return(fuel)
  exit
end

on setSpeed(me, theSpeed)
  reachForSpeed = 0
  acceleration = 0
  speed = theSpeed * decimalPrec
  if speed > 0 then
    forwardBackward = 1
  else
    if speed < 0 then
      forwardBackward = -1
    else
      forwardBackward = 0
    end if
  end if
  exit
end

on setTopology(me, theTopo)
  exit
end

on setDirection(me, theDirection)
  direction = correctDirection(gDir.drivingHandlers, theDirection)
  internalDirection = direction * decimalPrec
  exit
end

on programControl(me, YesNo, theCheck)
  userSteer = not YesNo
  if theCheck = #NoCheck then
    shouldCheckGround = 0
  else
    shouldCheckGround = 1
  end if
  exit
end

on step(me)
  frameCount = frameCount + 1
  calculateSpeed(me)
  if reachForSpeed then
    if acceleration = 1 then
      if speed >= reachForSpeed then
        speed = reachForSpeed
        reachForSpeed = 0
      end if
    else
      if speed <= reachForSpeed then
        speed = reachForSpeed
        reachForSpeed = 0
      end if
    end if
  end if
  if Steering then
    tempLastIntDir = internalDirection
    internalDirection = internalDirection + Steering * getaProp(quickCarProps, #Steering)
    if internalDirection > nrOfDirections * decimalPrec then
      internalDirection = internalDirection - nrOfDirections * decimalPrec
    else
      if internalDirection <= 0 then
        internalDirection = nrOfDirections * decimalPrec + internalDirection
      end if
    end if
    tempLastDir = direction
    direction = internalDirection / decimalPrec
    if direction > nrOfDirections then
      direction = 1
    else
      if direction < 1 then
        direction = nrOfDirections
      end if
    end if
    if speed = 0 then
    end if
  end if
  if reachForDirection then
    reachForDirection = 0
    Steering = 0
  end if
  if speed then
    lastCoordinate = duplicate(coordinate)
    diff = speed * getAt(directionList, direction) / decimalPrec
    coordinate = coordinate + diff
  end if
  exit
end

on calculateSpeed(me)
  if stopTimer > 0 then
    stopTimer = stopTimer - 1
  end if
  if acceleration then
    if stopTimer = 0 then
      if forwardBackward = 0 then
        tempAcc = acceleration * getaProp(quickCarProps, #acceleration)
      else
        if forwardBackward = acceleration then
          tempAcc = acceleration * getaProp(quickCarProps, #acceleration)
        else
          tempAcc = acceleration * getaProp(quickCarProps, #break)
          if abs(speed) <= maxAcc then
            speed = 0
            stopTimer = 5
            tempAcc = 0
          end if
        end if
      end if
      tempMax = getaProp(quickCarProps, #speed) * keySteer * 25 + 75 / 100
      if speed <= tempMax and speed >= -tempMax / 2 then
        speed = speed + tempAcc
      end if
      if speed > tempMax then
        speed = tempMax
      else
        if speed < -tempMax / 4 then
          speed = -tempMax / 4
        end if
      end if
    end if
    if speed > 0 then
      forwardBackward = 1
    else
      if speed < 0 then
        forwardBackward = -1
      else
        forwardBackward = 0
      end if
    end if
  end if
  exit
end