on new(me)
  carCopy = gMulleGlobals.user.car
  ancestor = new(script("GeneralAncestor"), me)
  drivingHandlers = new(script("DrivingHandlers"))
  spriteList = [#map:1, #ObjectsUnder:5, #ObjectsOver:21, #car:20, #medal:64, #KPH:58, #Petrol:59, #fDialog:110, #ShowCar:55, #RealCar:20, #ShowOff:50]
  nextDir = ""
  mode = #Preparing
  maxObjects = 5
  maxSPUnder = 15
  maxSPOver = 10
  objects = []
  keyHandlers = new(script("KeyHandlers"))
  sprite(getProp(spriteList, #map)).undefined = point(320, 396 / 2 + 4)
  openXtra(gPathGlobals, #KeyPoll)
  gotKeyPoll = findXtra(gPathGlobals, "KeyPoll")
  loadWorld(me)
  setProp(spriteList, #car, getProp(spriteList, #ShowCar))
  mode = #Showing
  return(me)
  exit
end

on loadWorld(me)
  if not objectp(gMulleGlobals.world) then
    gMulleGlobals.world = new(script("World"))
    gMulleGlobals.worlds.lastWorld = 0
  end if
  if not isSameWorld(gMulleGlobals.worlds) then
    oneWorld = gMulleGlobals.worlds.activeWorld
    if oneWorld = 0 then
      oneWorld = getAt(getAt(getWorldSymbols(gMulleGlobals.worlds), 1), 2)
    end if
    status = loadWorld(gMulleGlobals.worlds, gMulleGlobals.world, oneWorld)
    if symbolp(status) then
      alert("World error: " & string(status))
      exit
    end if
    calcRandomDestinations(gMulleGlobals.world)
  end if
  if getDrivingInfo(gMulleGlobals.user) = 0 then
    randomizeDestinations(gMulleGlobals.world)
  end if
  calcCurrentlyAvailable(gMulleGlobals.externalParts)
  map = new(script("Map"))
  status = loadMap(gMulleGlobals.maps, map, getCurrentMapId(gMulleGlobals.world))
  if symbolp(status) then
    alert("Map error:" & string(status))
    exit
  end if
  exit
end

on init(me)
  usedArrows = 0
  tempInfo = getDrivingInfo(gMulleGlobals.user)
  if tempInfo = 0 then
    tempInfo = getStartInfo(gMulleGlobals.world)
    startFuel = #Full
    startKeySteer = 1
  else
    startFuel = getaProp(tempInfo, #fuel)
    startKeySteer = getaProp(tempInfo, #keySteer)
  end if
  changeMap(me, getaProp(tempInfo, #map), #Absolute, 0)
  setDoIdle(keyHandlers, 0)
  exit
end

on startCar(me)
  sprite(getProp(spriteList, #ShowCar)).undefined = member("Dummy")
  if not objectp(carDriving) then
    carDriving = new(script("CarDriving"))
  end if
  tempInfo = getDrivingInfo(gMulleGlobals.user)
  if tempInfo = 0 then
    tempInfo = getStartInfo(gMulleGlobals.world)
    startFuel = #Full
    startKeySteer = 1
  else
    startFuel = getaProp(tempInfo, #fuel)
    startKeySteer = getaProp(tempInfo, #keySteer)
  end if
  setKeySteer(me, startKeySteer)
  init(carDriving, [#StartCoordinate:getaProp(tempInfo, #coordinate), #StartDirection:getaProp(tempInfo, #direction), #startFuel:startFuel])
  changeMap(me, getaProp(tempInfo, #map), #Absolute)
  checkTerrain(carDriving)
  setDoIdle(keyHandlers, 1)
  sendSprite(getProp(spriteList, #Petrol), #init)
  mode = #Driving
  exit
end

on startMovie(me)
  sprite(118).undefined = member("Dummy")
  sprite(119).undefined = member("Dummy")
  stopBG(gSound)
  stopAllEffects(gSound)
  sendSprite(115, #MEnter, "00b023v0", 1)
  exit
end

on teleport(me, theWorld, theMap, theLoc)
  gMulleGlobals.worlds.activeWorld = theWorld
  loadWorld(me)
  changeMap(me, theMap, #Absolute)
  setCoordinate(carDriving, theLoc)
  exit
end

on changeMap(me, thePoint, theMode, theRealInit)
  if voidp(theMode) then
    theMode = #Relational
  end if
  if voidp(thePoint) then
    thePoint = point(0, 0)
  end if
  temp = getNewMapId(gMulleGlobals.world, thePoint, theMode)
  if integerp(temp) then
    if theMode = #Relational then
      mapCoordinate = mapCoordinate + thePoint
    else
      mapCoordinate = thePoint
    end if
    status = loadMap(gMulleGlobals.maps, map, temp)
    if symbolp(status) then
      alert("Map error:" & string(status))
      exit
    end if
    sprite(getProp(spriteList, #map)).undefined = member(getMapImage(map))
    if voidp(theRealInit) then
      setTopology(carDriving, getTopology(map))
      correctedCarLoc = 0
      goThroughObjects(me)
      if listp(correctedCarLoc) then
        setCoordinate(carDriving, correctedCarLoc, #AdjustTopo)
      end if
    end if
    return(1)
  else
    return(0)
  end if
  exit
end

on prepareToLeave(me, toDir)
  gMulleGlobals.WhereFrom = "05"
  stopEngine(carDriving.displayObject)
  nextDir = toDir
  if toDir = "04" or toDir = "03" then
    setDrivingInfo(gMulleGlobals.user, 0)
    go("GoHome")
    exit
  else
    if toDir = "08" then
      tempList = [#map:mapCoordinate, #direction:getDirection(carDriving), #coordinate:getCoordinate(carDriving), #fuel:carDriving.fuel, #keySteer:carDriving.keySteer]
      setDrivingInfo(gMulleGlobals.user, tempList)
      go("08")
      exit
    else
      tempList = [#map:mapCoordinate, #direction:getDirection(carDriving), #coordinate:getCoordinate(carDriving), #fuel:carDriving.fuel, #keySteer:carDriving.keySteer]
      setDrivingInfo(gMulleGlobals.user, tempList)
      go("Leave")
    end if
  end if
  exit
end

on loop(me)
  if mode = #Driving then
    carLoc = getShowCoordinate(carDriving)
    -- UNK_64 0
    -- UNK_64 0
    -- UNK_64 2
    repeat while ERROR <= ERROR
      -- UNK_64 2
      -- UNK_64 1
      index = getAt()
      step(index, carLoc)
    end repeat
    -- UNK_65 3
  end if
  loop(ancestor)
  exit
end

on loginEnd(me)
  exit
end

on goThroughObjects(me)
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    index = getAt()
    kill(index)
  end repeat
  -- UNK_65 3
  objects = []
  rDests = getRandomDestinations(gMulleGlobals.world)
  tempSPUnder = getProp(spriteList, #ObjectsUnder)
  tempSPOver = getProp(spriteList, #ObjectsOver)
  n = 0
  repeat while n <= maxSPUnder - 1
    sprite(tempSPUnder + n).undefined = member("Dummy")
    n = 1 + n
  end repeat
  n = 0
  repeat while n <= maxSPOver - 1
    sprite(tempSPOver + n).undefined = member("Dummy")
    n = 1 + n
  end repeat
  objectsData = getObjects(map)
  SPCounterUnder = 0
  SPCounterOver = 0
  tempCarLoc = getShowCoordinate(carDriving)
  n = 1
  repeat while n <= count(objectsData)
    tempObj = new(script("Object"))
    tempObjData = getAt(objectsData, n)
    ObjectId = getAt(tempObjData, 1)
    objectLoc = getAt(tempObjData, 2)
    if count(tempObjData) = 3 then
      objectOptional = getAt(tempObjData, 3)
    else
      objectOptional = []
    end if
    if fromList(tempObj, ObjectId) then
      tempOK = 0
      if getType(tempObj) = #rdest then
        tempInMap = getaProp(rDests, ObjectId)
        if tempInMap = mapCoordinate then
          tempOK = 1
        end if
      else
        if getType(tempObj) = #Correct then
          tempDiff = tempCarLoc - objectLoc
          tempH = getAt(tempDiff, 1)
          tempV = getAt(tempDiff, 2)
          hypo = sqrt(tempH * tempH + tempV * tempV)
          if count(objectOptional) = 0 then
            tempRadius = 80
          else
            tempRadius = getaProp(objectOptional, #InnerRadius)
            if voidp(tempRadius) then
              tempRadius = 80
            end if
          end if
          if hypo < tempRadius then
            correctedCarLoc = objectLoc
          end if
        else
          tempOK = 1
        end if
      end if
      if tempOK then
        showIt = init(tempObj, [SPCounterOver + tempSPOver, SPCounterUnder + tempSPUnder], objectLoc, objectOptional, tempCarLoc)
        if showIt then
          tempSPInfo = getSpritesInfo(tempObj)
          m = 1
          repeat while m <= count(tempSPInfo)
            -- UNK_64 0
            if ERROR = #over then
              SPCounterOver = SPCounterOver + getAt(tempSPInfo, m)
            else
              -- UNK_64 0
              if ERROR = #Under then
                SPCounterUnder = SPCounterUnder + getAt(tempSPInfo, m)
              end if
            end if
            -- UNK_65 1
            m = 1 + m
          end repeat
          add(objects, tempObj)
        end if
      end if
    end if
    n = 1 + n
  end repeat
  exit
end

on setKeySteer(me, YesNo)
  if voidp(YesNo) then
    YesNo = carDriving.keySteer
  end if
  carDriving.keySteer = YesNo
  if YesNo then
    sendSprite(115, #setMode, #Keys)
  else
    sendSprite(115, #setMode, #mouse)
  end if
  exit
end

on keyDown(me, which)
  if mode = #Driving then
    if carDriving.userSteer then
      -- UNK_64 0
      if ERROR = #left then
        steer(carDriving, -1)
      else
        -- UNK_64 0
        if ERROR = #right then
          steer(carDriving, 1)
        else
          -- UNK_64 0
          if ERROR = #up then
            usedArrows = 0
            changeSpeed(carDriving, 1)
          else
            -- UNK_64 0
            if ERROR = #down then
              usedArrows = 0
              changeSpeed(carDriving, -1)
            else
              -- UNK_64 0
              if ERROR = #ArrowUp then
                usedArrows = 1
                changeSpeed(carDriving, 1)
              else
                -- UNK_64 0
                if ERROR = #ArrowDown then
                  usedArrows = 1
                  changeSpeed(carDriving, -1)
                end if
              end if
            end if
          end if
        end if
      end if
      -- UNK_65 1
    end if
  end if
  exit
end

on keyUp(me, which)
  if mode = #Driving then
    if carDriving.userSteer then
      if which = #up or which = #down then
        changeSpeed(carDriving, 0)
      else
        if usedArrows then
          changeSpeed(carDriving, 0)
        end if
        steer(carDriving, 0)
      end if
    end if
  end if
  exit
end

on changecarSound(me)
  if objectp(carDriving) then
    changecarSound(carDriving.displayObject)
  end if
  exit
end

on stopSound(me)
  sendSprite(getProp(spriteList, #medal), #stopSound)
  stopSound(carDriving)
  exit
end

on activate(me, YesNo)
  if YesNo then
    mode = #Driving
    setDoIdle(keyHandlers, 1)
    if wasSoundOn then
      changecarSound(carDriving.displayObject, 1)
    end if
  else
    stopBG(gSound)
    if not mode = #Showing then
      wasSoundOn = carDriving.displayObject.soundOn
      carDriving.keySteer = keyHandlers.wasKeySteer
      setKeySteer(me, keyHandlers.wasKeySteer)
    end if
    mode = #Waiting
    setDoIdle(keyHandlers, 0)
  end if
  exit
end

on OutOfFuel(me, lastToEnd)
  mode = #OutOfGas
  tempObj = new(script("OutOfFuelScript"), lastToEnd)
  exit
end

on kill(me)
  if objectp(keyHandlers) then
    keyHandlers = kill(keyHandlers)
  end if
  if objectp(carDriving) then
    carDriving = kill(carDriving)
  end if
  drivingHandlers = kill(drivingHandlers)
  ancestor = kill(ancestor)
  return(0)
  exit
end