on new(me)
  speed = 0
  direction = 0
  fuel = 0
  coordinate = point(0, 0)
  lastCoordinate = point(0, 0)
  userSteer = 1
  internalDirection = 0
  waitForTurn = 0
  Steering = 0
  lastMouseLoc = point(0, 0)
  nrOfDirections = 16
  decimalPrec = 100
  stopTimer = 0
  Topology = ""
  directionList = []
  reachForSpeed = 0
  reachForDirection = 0
  keySteer = 1
  forwardBackward = 0
  altitude = 0
  inclination = 0
  frameCount = 0
  shouldCheckGround = 1
  mouseForward = 1
  cursorDirection = 1
  previousData = []
  n = 1
  repeat while n <= 10
    temp = []
    add(temp, point(0, 0))
    add(temp, 1)
    add(temp, 0)
    add(previousData, duplicate(temp))
    n = 1 + n
  end repeat
  thisHit = 0
  directionLock = 0
  inTerrain = 0
  pi = pi()
  n = 1
  repeat while n <= nrOfDirections
    tempAngle = pi() * 2 * n / float(nrOfDirections)
    xPart = integer(decimalPrec * sin(tempAngle))
    yPart = -integer(decimalPrec * cos(tempAngle))
    add(directionList, point(xPart, yPart))
    n = 1 + n
  end repeat
  quickCarProps = duplicate(gDir.carCopy.carProperties)
  if getaProp(quickCarProps, #Strength) = 0 then
    makeCar(#Good)
  end if
  tempSounds = ["05e050v0", "05e049v0", "05e044v0", "05e042v0", "05d013v0"]
  tempHorn = getaProp(quickCarProps, #HornType)
  if tempHorn > 0 and tempHorn <= count(tempSounds) then
    hornSound = getAt(tempSounds, getProp(quickCarProps, #HornType))
  else
    hornSound = getAt(tempSounds, 1)
  end if
  return(me)
  exit
end

on convertCarProps(me)
  gotElectricEngine = 0
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    partId = getAt()
    part = getPart(gMulleGlobals.parts, partId)
    if getProperty(part, #ElectricConsumption) > 0 then
      gotElectricEngine = 1
    else
    end if
  end repeat
  -- UNK_65 3
  if gotElectricEngine then
    if getaProp(quickCarProps, #ElectricConsumption) < 0 then
      setProp(quickCarProps, #ElectricConsumption, 0)
    end if
  else
    setProp(quickCarProps, #ElectricVolume, 0)
  end if
  if getaProp(quickCarProps, #FuelConsumption) = 0 then
    setProp(quickCarProps, #FuelVolume, 0)
  end if
  if getaProp(quickCarProps, #speed) = 5 then
    setProp(quickCarProps, #speed, getaProp(quickCarProps, #speed) * decimalPrec * 27 / 10)
  else
    setProp(quickCarProps, #speed, getaProp(quickCarProps, #speed) * decimalPrec * 20 / 10)
  end if
  setProp(quickCarProps, #break, getaProp(quickCarProps, #break) * decimalPrec * 3 / 10)
  if getaProp(quickCarProps, #acceleration) = 0 then
    setProp(quickCarProps, #acceleration, 1)
  end if
  setProp(quickCarProps, #acceleration, getaProp(quickCarProps, #acceleration) * decimalPrec * 2 / 10)
  setProp(quickCarProps, #Steering, getaProp(quickCarProps, #Steering) + 3 * decimalPrec * 2 / 20)
  setProp(quickCarProps, #FuelVolume, getaProp(quickCarProps, #FuelVolume) * decimalPrec * 12)
  setProp(quickCarProps, #ElectricVolume, getaProp(quickCarProps, #ElectricVolume) * decimalPrec * 15)
  maxAcc = getaProp(quickCarProps, #break)
  if maxAcc < getaProp(quickCarProps, #acceleration) then
    maxAcc = getaProp(quickCarProps, #acceleration)
  end if
  criteria = [#MudGrip:8, #HolesDurability:3, #BigHill:3, #SmallHill:2]
  if getProp(quickCarProps, #Grip) > getProp(criteria, #MudGrip) then
    setProp(criteria, #MudGrip, 1)
  else
    setProp(criteria, #MudGrip, 0)
  end if
  if getProp(quickCarProps, #Durability) > getProp(criteria, #HolesDurability) then
    setProp(criteria, #HolesDurability, 1)
  else
    setProp(criteria, #HolesDurability, 0)
  end if
  if getProp(quickCarProps, #Strength) > getProp(criteria, #BigHill) then
    setProp(criteria, #BigHill, 1)
  else
    setProp(criteria, #BigHill, 0)
  end if
  if getProp(quickCarProps, #Strength) > getProp(criteria, #SmallHill) then
    setProp(criteria, #SmallHill, 1)
  else
    setProp(criteria, #SmallHill, 0)
  end if
  setEngine(displayObject)
  exit
end

on kill(me)
  wheels = kill(wheels)
  displayObject = kill(displayObject)
  return(0)
  exit
end

on init(me, theWorld)
  if not objectp(displayObject) then
    displayObject = new(script("DisplayCar"), me)
  end if
  if not objectp(wheels) then
    wheels = new(script("Wheels"), me)
  end if
  start(me, theWorld)
  exit
end

on start(me, theWorld)
  speed = 0
  Steering = 0
  coordinate = decimalPrec * getProp(theWorld, #StartCoordinate)
  direction = getProp(theWorld, #StartDirection)
  internalDirection = decimalPrec * direction
  tempFuel = getProp(theWorld, #startFuel)
  if listp(tempFuel) then
    fuel = tempFuel
    updateProperties(gMulleGlobals.user.car)
    quickCarProps = duplicate(gDir.carCopy.carProperties)
    convertCarProps(me)
  else
    fillErUp(me)
  end if
  setCoordinate(wheels, coordinate)
  exit
end

on getCoordinate(me)
  return(coordinate / decimalPrec)
  exit
end

on setCoordinate(me, theCoord, theOption)
  coordinate = theCoord * decimalPrec
  if theOption = #AdjustTopo then
    checkTerrain(me)
    coordinate = coordinate + point(0, 3) * altitude * decimalPrec
  end if
  exit
end

on getShowCoordinate(me)
  return(coordinate / decimalPrec - point(0, 3) * altitude)
  exit
end

on getInclination(me)
  return(inclination)
  exit
end

on getSpeed(me)
  return(speed / decimalPrec)
  exit
end

on getDirection(me)
  return(direction)
  exit
end

on show(me, YesNo)
  show(displayObject, YesNo)
  exit
end

on saveData(me, before)
  if integerp(before) then
    rememberThis = duplicate(getAt(previousData, count(previousData) - before))
  else
    if before = #none then
      rememberThis = 0
    else
      rememberThis = [duplicate(coordinate), direction, thisHit]
    end if
  end if
  exit
end

on restoreData(me)
  if listp(rememberThis) then
    coordinate = getAt(rememberThis, 1)
    direction = getAt(rememberThis, 2)
    thisHit = getAt(rememberThis, 3)
    temp = count(previousData)
    previousData = []
    n = 1
    repeat while n <= temp
      add(previousData, duplicate(rememberThis))
      n = 1 + n
    end repeat
    exit repeat
  end if
  exit
end

on steer(me, theDirection)
  if directionLock then
    exit
  end if
  Steering = theDirection
  reachForDirection = 0
  exit
end

on lockDirection(me, YesNo)
  directionLock = YesNo
  Steering = 0
  exit
end

on changeSpeed(me, upDown)
  acceleration = upDown
  reachForSpeed = 0
  exit
end

on stepback(me, theNr)
  if theNr = #Remembered then
    if listp(rememberThis) then
      temp = duplicate(rememberThis)
    else
      temp = getAt(previousData, count(previousData) - 1)
    end if
  else
    temp = getAt(previousData, count(previousData) - theNr + 1)
  end if
  coordinate = getAt(temp, 1)
  direction = getAt(temp, 2)
  exit
end

on fillErUp(me)
  updateProperties(gMulleGlobals.user.car)
  quickCarProps = duplicate(gDir.carCopy.carProperties)
  convertCarProps(me)
  tempExtra = getCacheProp(gMulleGlobals.user.car, #ExtraTank)
  if tempExtra = #NoProp then
    tempExtra = 0
  end if
  sendSprite(getProp(gDir.spriteList, #Petrol), #fillErUp, tempExtra)
  tempExtra = tempExtra + 100
  tempGas = tempExtra * getaProp(quickCarProps, #FuelVolume) / 100
  if gotElectricEngine then
    tempElec = getaProp(quickCarProps, #ElectricVolume)
  else
    tempElec = 0
  end if
  fuel = [tempGas, tempElec]
  exit
end

on getFuel(me)
  return(fuel)
  exit
end

on setSpeed(me, theSpeed)
  reachForSpeed = 0
  acceleration = 0
  speed = theSpeed * decimalPrec
  if speed > 0 then
    forwardBackward = 1
  else
    if speed < 0 then
      forwardBackward = -1
    else
      forwardBackward = 0
    end if
  end if
  exit
end

on setTopology(me, theTopo)
  setTopology(wheels, theTopo)
  exit
end

on setDirection(me, theDirection)
  direction = correctDirection(gDir.drivingHandlers, theDirection)
  internalDirection = direction * decimalPrec
  exit
end

on programControl(me, YesNo, theCheck)
  userSteer = not YesNo
  if theCheck = #NoCheck then
    shouldCheckGround = 0
  else
    shouldCheckGround = 1
  end if
  exit
end

on step(me)
  frameCount = frameCount + 1
  if userSteer and not keySteer and not directionLock then
    mouseSteer(me)
  end if
  calculateSpeed(me)
  if reachForSpeed then
    if acceleration = 1 then
      if speed >= reachForSpeed then
        speed = reachForSpeed
        reachForSpeed = 0
      end if
    else
      if speed <= reachForSpeed then
        speed = reachForSpeed
        reachForSpeed = 0
      end if
    end if
  end if
  if Steering then
    tempLastIntDir = internalDirection
    internalDirection = internalDirection + Steering * getaProp(quickCarProps, #Steering)
    if internalDirection > nrOfDirections * decimalPrec then
      internalDirection = internalDirection - nrOfDirections * decimalPrec
    else
      if internalDirection <= 0 then
        internalDirection = nrOfDirections * decimalPrec + internalDirection
      end if
    end if
    tempLastDir = direction
    direction = internalDirection / decimalPrec
    if direction > nrOfDirections then
      direction = 1
    else
      if direction < 1 then
        direction = nrOfDirections
      end if
    end if
    if speed = 0 then
      if shouldCheckGround then
        checkTerrain(me)
      end if
    end if
  end if
  if reachForDirection then
    reachForDirection = 0
    Steering = 0
  end if
  if speed then
    tempChangedWheelCoord = 0
    lastCoordinate = duplicate(coordinate)
    diff = speed * getAt(directionList, direction) / decimalPrec
    tryCoordinate = coordinate + diff
    setCoordinate(wheels, tryCoordinate)
    if shouldCheckGround then
      Info = quickCheck(wheels, 0, direction, forwardBackward)
      if Info = 0 then
        tryCoordinate = makeTheBestOfHit(me, tryCoordinate)
        setCoordinate(wheels, tryCoordinate)
        tempChangedWheelCoord = 1
        Info = quickCheck(wheels, 0, direction, forwardBackward)
      end if
      if checkTerrain(me, Info) then
        coordinate = tryCoordinate
      end if
    else
      coordinate = tryCoordinate
    end if
    setCoordinate(wheels, coordinate)
    temp = checkBorders(wheels, direction, forwardBackward)
    if listp(temp) then
      if integerp(getNewMapId(gMulleGlobals.world, temp, #Relational, 1)) then
        if getAt(temp, 1) = -1 then
          coordinate = point(640 - 8 - 1 * decimalPrec, getAt(coordinate, 2))
        else
          if getAt(temp, 1) = 1 then
            coordinate = point(4 + 8 * decimalPrec, getAt(coordinate, 2))
          else
            if getAt(temp, 2) = -1 then
              coordinate = point(getAt(coordinate, 1), 396 - 1 * decimalPrec)
            else
              if getAt(temp, 2) = 1 then
                coordinate = point(getAt(coordinate, 1), 4 + 8 * decimalPrec)
              end if
            end if
          end if
        end if
        changeMap(gDir, temp)
        setCoordinate(wheels, coordinate)
      else
        stepback(me, 1)
        setSpeed(me, 0)
      end if
    end if
  end if
  tempNoFuel = 0
  temp = getAt(fuel, 1)
  if temp > 0 then
    temp = temp - abs(speed) * getaProp(quickCarProps, #FuelConsumption) / decimalPrec
    if temp > 0 then
      setAt(fuel, 1, temp)
    else
      setAt(fuel, 1, 0)
      if getAt(fuel, 2) = 0 then
        updateEngine(gDir.drivingHandlers, #NoFuel)
        tempNoFuel = 1
      else
        stopAllEffects(gSound)
        sendSprite(getProp(gDir.spriteList, #medal), #stop)
        play(gSound, "05d015v0", #EFFECT)
        updateEngine(gDir.drivingHandlers, #NoGas)
      end if
      quickCarProps = duplicate(gMulleGlobals.user.car.carProperties)
      convertCarProps(me)
    end if
  end if
  temp = getAt(fuel, 2)
  if temp > 0 then
    temp = temp - abs(speed) * getaProp(quickCarProps, #ElectricConsumption) / decimalPrec
    if temp > 0 then
      setAt(fuel, 2, temp)
    else
      setAt(fuel, 2, 0)
      if getAt(fuel, 1) = 0 then
        updateEngine(gDir.drivingHandlers, #NoFuel)
        tempNoFuel = 2
      else
        stopAllEffects(gSound)
        sendSprite(getProp(gDir.spriteList, #medal), #stop)
        play(gSound, "05d016v0", #EFFECT)
        updateEngine(gDir.drivingHandlers, #NoElectricity)
      end if
      quickCarProps = duplicate(gMulleGlobals.user.car.carProperties)
      convertCarProps(me)
    end if
  end if
  if tempNoFuel then
    if not getaProp(quickCarProps, #Pedals) then
      setProp(quickCarProps, #speed, decimalPrec)
      programControl(me, 1)
      setSpeed(me, 0)
      changecarSound(displayObject, 0)
      OutOfFuel(gDir, tempNoFuel)
      exit
    else
      stopAllEffects(gSound)
      sendSprite(getProp(gDir.spriteList, #medal), #stop)
      play(gSound, "05d017v0", #EFFECT)
    end if
  end if
  if userSteer then
    temp = [duplicate(coordinate), direction, thisHit]
    add(previousData, temp)
    deleteAt(previousData, 1)
    thisHit = 0
  end if
  exit
end

on mouseSteer(me)
  temp = getAt(getAt(previousData, count(previousData) - 1), 3)
  if temp = #stop or temp = #Turn then
    Steering = 0
    reachForDirection = 0
    exit
  end if
  temp = calcDirection(gDir.drivingHandlers, getShowCoordinate(me), point(the mouseH, the mouseV), #WithHypo)
  tempDirection = getAt(temp, 1)
  cursorDirection = tempDirection
  hypo = getAt(temp, 2)
  reachForDirection = 1
  diff = tempDirection - direction
  if abs(diff) >= nrOfDirections / 2 then
    diff = -diff
  end if
  if diff > 0 then
    Steering = 1
  else
    if diff < 0 then
      Steering = -1
    else
      Steering = 0
    end if
  end if
  exit
end

on calculateSpeed(me)
  if stopTimer > 0 then
    stopTimer = stopTimer - 1
  end if
  if acceleration then
    if stopTimer = 0 then
      if forwardBackward = 0 then
        tempAcc = acceleration * getaProp(quickCarProps, #acceleration)
      else
        if forwardBackward = acceleration then
          tempAcc = acceleration * getaProp(quickCarProps, #acceleration)
        else
          tempAcc = acceleration * getaProp(quickCarProps, #break)
          if abs(speed) <= maxAcc then
            speed = 0
            stopTimer = 5
            tempAcc = 0
          end if
        end if
      end if
      tempMax = getaProp(quickCarProps, #speed) * keySteer * 25 + 75 / 100
      if speed <= tempMax and speed >= -tempMax / 2 then
        speed = speed + tempAcc
      end if
      if speed > tempMax then
        speed = tempMax
      else
        if speed < -tempMax / 4 then
          speed = -tempMax / 4
        end if
      end if
    end if
    if speed > 0 then
      forwardBackward = 1
    else
      if speed < 0 then
        forwardBackward = -1
      else
        forwardBackward = 0
      end if
    end if
  end if
  exit
end

on makeTheBestOfHit(me, tryCoordinate)
  if objectp(wheels) then
    if keySteer then
      sideStepLimit = decimalPrec * 4
    else
      sideStepLimit = decimalPrec * 3
    end if
    hitInfo = checkHit(wheels, coordinate, tryCoordinate, speed, direction, sideStepLimit)
    if listp(hitInfo) then
      if getAt(hitInfo, 2) = #sideStep then
        thisHit = getAt(hitInfo, 2)
        speed = 7 * speed / 8
        return(getAt(hitInfo, 1))
        exit
      else
        return(getAt(hitInfo, 1))
        exit
      end if
    end if
    howBad = whichSideIsFree(wheels, coordinate, speed, direction)
    if howBad < 0 then
      leftRight = -1
    else
      leftRight = 1
    end if
    howBad = abs(howBad)
    tempTurn = 1
    if not getAt(getAt(previousData, count(previousData)), 3) = #stop then
      tempTurn = 0
    end if
    if howBad > 2 or speed < 3 * decimalPrec and tempTurn = 0 then
      speed = 0
      forwardBackward = 0
      thisHit = #stop
      setDirection(me, direction + leftRight)
      return(findEdge(wheels, coordinate, tryCoordinate, speed, direction))
    else
      speed = 3 * speed / 4
      if keySteer then
        setDirection(me, direction + leftRight)
      else
        setDirection(me, direction + leftRight * 2)
      end if
      thisHit = #Turn
    end if
    if abs(speed) < maxAcc then
      speed = 0
      forwardBackward = 0
    end if
    return(tryCoordinate)
  end if
  exit
end

on checkTerrain(me, Info)
  if voidp(Info) then
    Info = quickCheck(wheels, 0, direction, forwardBackward)
  end if
  if Info = 0 then
    return(1)
  end if
  inclination = getAt(Info, 3) - getAt(Info, 4)
  if inclination then
    if inclination > 0 then
      speed = 100 - forwardBackward * 10 * speed / 100
      if inclination > 2 then
        inclination = 2
        if getProp(quickCarProps, #Strength) <= getProp(criteria, #BigHill) then
          setSpeed(me, 0)
          stepback(me, 1)
          return(0)
        else
          tempMedalId = 1
          if getMedal(gMulleGlobals.user.car, tempMedalId) = 0 then
            playSound(me, #MedalMud)
            sendSprite(getProp(gDir.spriteList, #medal), #Blink, tempMedalId)
            addMedal(gMulleGlobals.user.car, tempMedalId)
          end if
        end if
      else
        if inclination > 1 then
          if getProp(quickCarProps, #Strength) <= getProp(criteria, #SmallHill) then
            setSpeed(me, 0)
            stepback(me, 1)
            return(0)
          end if
        end if
      end if
    else
      speed = 100 + forwardBackward * 10 * speed / 100
      if inclination < -2 then
        inclination = -2
      end if
    end if
  end if
  altitude = getAt(Info, 3) + getAt(Info, 4) / 2
  if getAt(Info, 1) or getAt(Info, 2) then
    if getAt(Info, 1) and getAt(Info, 2) then
      -- UNK_64 0
      if ERROR = 1 then
        if getProp(criteria, #HolesDurability) = 0 then
          playSound(me, #Durability)
          speed = 0
          return(0)
        end if
        speed = 80 * speed / 100
        if not inTerrain then
          inTerrain = getAt(Info, 1)
        end if
      else
        -- UNK_64 0
        if ERROR = 2 then
          if getProp(criteria, #MudGrip) = 0 then
            playSound(me, #Grip)
            speed = 0
            return(0)
          end if
          speed = 80 * speed / 100
          if not inTerrain then
            tempMedalId = 3
            if getMedal(gMulleGlobals.user.car, tempMedalId) = 0 then
              sendSprite(getProp(gDir.spriteList, #medal), #Blink, tempMedalId)
              addMedal(gMulleGlobals.user.car, tempMedalId)
            end if
            inTerrain = getAt(Info, 1)
          end if
        end if
      end if
      -- UNK_65 1
    else
      if speed > 0 then
        tempInfo = getAt(Info, 1)
      else
        tempInfo = getAt(Info, 2)
      end if
      -- UNK_64 0
      if ERROR = 1 then
        if getProp(criteria, #HolesDurability) = 0 then
          playSound(me, #Durability)
          speed = 0
          return(0)
        end if
      else
        -- UNK_64 0
        if ERROR = 2 then
          if getProp(criteria, #MudGrip) = 0 then
            playSound(me, #Grip)
            speed = 0
            return(0)
          end if
        end if
      end if
      -- UNK_65 1
    end if
  else
    inTerrain = 0
  end if
  return(1)
  exit
end

on stopSound(me)
  stop(gSound, sndId)
  exit
end

on playSound(me, what)
  tempList = [#Durability:["05d002v0"], #Grip:["05d003v0"], #Strength:["05d004v0", "05d005v0"]]
  temp = getaProp(tempList, what)
  if listp(temp) then
    snd = getAt(temp, random(count(temp)))
    if finished(gSound, sndId) then
      sndId = play(gSound, snd, #EFFECT)
    end if
  end if
  exit
end