on new(me, theReportObject)
  reportObject = theReportObject
  decimalPrec = reportObject.decimalPrec
  directionList = duplicate(reportObject.directionList)
  wheelPositions = []
  n = 1
  repeat while n <= count(directionList)
    add(wheelPositions, 5 * getAt(directionList, n) / decimalPrec)
    n = 1 + n
  end repeat
  clockList = [point(1, -1), point(1, 0), point(1, 1), point(0, 1), point(-1, 1), point(-1, 0), point(-1, -1), point(0, -1)]
  coordinate = point(0, 0)
  mapOffset = point(4, 4)
  return(me)
  exit
end

on kill(me)
  return(0)
  exit
end

on setTopology(me, theTopo)
  Topology = member(theTopo).text & member(theTopo & "-2").text
  exit
end

on setCoordinate(me, theCoordinate)
  lastCoordinate = coordinate
  coordinate = theCoordinate / decimalPrec - mapOffset / 2
  exit
end

on checkBorders(me, theDirection, theForward)
  tempH = getAt(coordinate, 1)
  tempV = getAt(coordinate, 2)
  if theForward = 1 then
    temp = getAt(wheelPositions, abs(theDirection))
    tempH = tempH + getAt(temp, 1)
    tempV = tempV + getAt(temp, 2)
  end if
  tempIn = 2
  if tempH < 1 + tempIn then
    return(point(-1, 0))
  else
    if tempH > 316 - tempIn then
      return(point(1, 0))
    else
      if tempV < 1 + tempIn then
        return(point(0, -1))
      else
        if tempV > 198 - tempIn then
          return(point(0, 1))
        end if
      end if
    end if
  end if
  return(0)
  exit
end

on quickCheck(me, theCoordinate, theWhat, theForward)
  if not listp(theCoordinate) then
    theCoordinate = coordinate
  end if
  if integerp(theWhat) then
    if theWhat >= 1 and theWhat <= 16 then
      tempH = getAt(theCoordinate, 1)
      tempV = getAt(theCoordinate, 2)
      middle = charToNum(Topology.char[tempH + tempV - 1 * 316])
      temp = getAt(wheelPositions, abs(theWhat))
      tempH = tempH + getAt(temp, 1)
      tempV = tempV + getAt(temp, 2)
      front = charToNum(Topology.char[tempH + tempV - 1 * 316])
      if theForward >= 0 and front >= 240 then
        return(0)
      else
        if theForward < 0 and middle >= 240 then
          return(0)
        end if
      end if
      if front >= 240 then
        front = middle
      else
        if middle >= 240 then
          middle = front
        end if
      end if
      return([front / 16, middle / 16, front mod 16, middle mod 16])
    end if
  else
    tempH = getAt(theCoordinate, 1)
    tempV = getAt(theCoordinate, 2)
    middle = charToNum(Topology.char[tempH + tempV - 1 * 316])
    if middle >= 240 then
      return(0)
    end if
    return(1)
  end if
  exit
end

on checkHit(me, theLastCoordinate, theTryCoordinate, speed, direction, theSideStepLimit)
  if abs(speed) <= 2 * decimalPrec then
    myLastCoord = theLastCoordinate / decimalPrec - mapOffset / 2
    if speed > 0 then
      myLastCoord = myLastCoord + getAt(wheelPositions, direction)
    end if
    lastTry = moveAtLeastAStep(me, direction, #Tangent, speed, myLastCoord)
    if not lastTry = 0 then
      if speed > 0 then
        lastTry = lastTry - getAt(wheelPositions, direction) * decimalPrec * 2
      end if
      return([lastTry, #Rounding])
    end if
    return(0)
  end if
  if speed > theSideStepLimit then
    theTryCoordinate = theTryCoordinate / decimalPrec - mapOffset / 2
    theTryCoordinate = theTryCoordinate + getAt(wheelPositions, direction)
    sideStep = moveAtLeastAStep(me, direction, #normal, 1, theTryCoordinate)
    if not sideStep = 0 then
      sideStep = sideStep - getAt(wheelPositions, direction) * decimalPrec * 2
      return([sideStep, #sideStep])
    end if
    sideStep = moveAtLeastAStep(me, direction, #normal, -1, theTryCoordinate)
    if not sideStep = 0 then
      sideStep = sideStep - getAt(wheelPositions, direction) * decimalPrec * 2
      return([sideStep, #sideStep])
    end if
  end if
  return(0)
  exit
end

on findEdge(me, theCoordinate, theTryCoordinate, speed, direction)
  return(theCoordinate)
  myLastCoord = theCoordinate / decimalPrec - mapOffset / 2
  theTryCoordinate = theTryCoordinate / decimalPrec - mapOffset / 2
  diff = theTryCoordinate - myLastCoord
  if speed > 0 then
    hereCoord = myLastCoord + getAt(wheelPositions, direction)
  end if
  if abs(getAt(diff, 1)) >= abs(getAt(diff, 2)) then
    nrOfSteps = getAt(diff, 1)
  else
    nrOfSteps = getAt(diff, 2)
  end if
  latestHit = 0
  latestFree = abs(nrOfSteps)
  put(latestHit, latestFree)
  if abs(nrOfSteps) <= 1 then
    nrOfSteps = 1
  else
    if nrOfSteps < 0 then
      sign = -1
    else
      sign = 1
    end if
    nrOfSteps = abs(nrOfSteps)
    step = 0
    half = 2
    free = 0
    repeat while 1
      tempDiff = 10 * nrOfSteps / half
      if abs(tempDiff) < 10 then
        if abs(latestFree - latestHit) = 1 then
        else
          if tempDiff > 0 then
            tempDiff = 10
          else
            tempDiff = -10
          end if
        end if
      end if
      step = step + tempDiff / 10
      newCoord = hereCoord + 100 * diff * step / nrOfSteps / 100
      middle = charToNum(Topology.char[getAt(newCoord, 1) + getAt(newCoord, 2) - 1 * 316])
      if middle >= 240 then
        free = 0
        latestHit = step
        half = abs(half) * 2
        next repeat
      end if
      free = 1
      latestFree = step
      half = abs(half) * -2
    end repeat
  end if
  put(latestHit, latestFree)
  return(myLastCoord + 100 * diff * latestFree / nrOfSteps / 100 * 2 + mapOffset * decimalPrec)
  exit
end

on showPoints(me, theSide)
  tempMid = theSide + 1 / 2
  y = 1
  repeat while y <= theSide
    x = 1
    repeat while x <= theSide
      sprite(63 + x + y - 1 * 5).foreColor = charToNum(Topology.char[getAt(coordinate, 1) + x - tempMid + getAt(coordinate, 2) + y - tempMid - 1 * 316])
      x = 1 + x
    end repeat
    y = 1 + y
  end repeat
  exit
end

on moveAtLeastAStep(me, theDirection, how, option, optCoord)
  if how = #normal then
    theDirection = theDirection + 4 * option
    theDirection = correctDirection(gDir.drivingHandlers, theDirection)
    option = 2 * decimalPrec
    if listp(optCoord) then
      thisCoord = optCoord
    else
      thisCoord = coordinate
    end if
  end if
  tempStep = getAt(directionList, theDirection)
  tempMax = abs(getAt(tempStep, 1))
  tempMin = abs(getAt(tempStep, 2))
  if tempMin > tempMax then
    tempMax = tempMin
  end if
  if how = #Tangent then
    if option < 0 then
      tempSign = -1
    else
      tempSign = 1
    end if
    if abs(option) * tempMax >= decimalPrec then
      option = tempSign * decimalPrec
    end if
    thisCoord = optCoord
  end if
  tempStep = option * tempStep / tempMax
  if how = #normal then
    tempCoord = thisCoord + tempStep + tempStep / 3 / decimalPrec
    realCoord = thisCoord + tempStep / 2 / decimalPrec
  else
    tempCoord = thisCoord + tempStep / decimalPrec
  end if
  if not quickCheck(me, tempCoord) = 0 then
    if how = #normal then
      return(realCoord * 2 + mapOffset * decimalPrec)
    else
      return(tempCoord * 2 + mapOffset * decimalPrec)
    end if
  end if
  return(0)
  exit
end

on whichSideIsFree(me, theCoordinate, speed, direction)
  theCoordinate = theCoordinate / decimalPrec - mapOffset / 2
  tempFree = 0
  n = 1
  repeat while n <= 5
    m = 1
    repeat while m <= 2
      if n = 2 then
        leftRight = -1
      else
        leftRight = 1
      end if
      tempDirection = correctDirection(gDir.drivingHandlers, direction + leftRight * n)
      diff = speed / decimalPrec * getAt(directionList, tempDirection) / decimalPrec
      if speed > 0 then
        tempCoordinate = theCoordinate + getAt(wheelPositions, tempDirection)
      end if
      newPoint = tempCoordinate + diff / 2
      if quickCheck(me, newPoint) then
        tempFree = 1
      else
        m = 1 + m
      end if
    end repeat
    if tempFree then
    else
      n = 1 + n
    end if
  end repeat
  return(n * leftRight)
  exit
end