on new(me)
  the mouseUpScript = "virtualMouseUp"
  the mouseDownScript = "virtualMouseDown"
  ancestor = new(script("GeneralAncestor"), me)
  spriteList = [#CarStart:2, #DeleteCar:112, #MedalsStart:59, #SmallCarStart:75, #PhotoBG:74, #loadCar:74, #YesButton:111, #NoButton:112, #EnterName:65, #SlotStart:46, #Flerp:45, #InsertCar:68, #Dialogue:114, #DialogueButton:113, #GoBack:66]
  slotOccupied = 0
  keyPressed = 0
  changedName = 0
  carSaved = 0
  if the frameLabel = "Save" then
    gMulleGlobals.WhereFrom = "06"
    mode = #save
    play(gSound, "06e002v0", #OPEFFECT)
    play(gSound, "06d001v0", #EFFECT)
  else
    gMulleGlobals.WhereFrom = "07"
    mode = #load
    if count(getSavedCars(gMulleGlobals.user, #all)) then
      play(gSound, "07d001v0", #EFFECT)
    else
      play(gSound, "07d003v0", #EFFECT)
    end if
  end if
  carPasted = 0
  cheatLoad = 0
  fileObject = new(script("FileStuff"))
  defaultFilename = ""
  doNextFrame = 0
  savedCarFiles = []
  return(me)
  exit
end

on init(me)
  gMulleGlobals.WhereFrom = the movieName.char[1..2]
  findFirstFree(me)
  exit
end

on startMovie(me)
  sendSprite(115, #C_Standard)
  sendSprite(getProp(spriteList, #SlotStart) + firstFree - 1, #clicked)
  if mode = #save then
    introObject = new(script("IntroScript"))
  end if
  exit
end

on checkText(me)
  changedName = 1
  tempKey = the key
  tempStr = member("SavedCarName").text
  tempLastLoc = getAt(charPosToLoc(member("SavedCarName"), length(tempStr)), 1)
  if tempLastLoc > 180 then
  end if
  if tempKey = "\r" then
    n = 1
    repeat while n <= length(tempStr)
      if tempStr.char[n] = "\r" then
      end if
      n = 1 + n
    end repeat
  end if
  member("SavedCarName").text = tempStr
  exit
end

on choseSlot(me, theChosenSlot, theSlotOccupied)
  saveIfNecessary(me)
  chosenSlot = theChosenSlot
  slotOccupied = theSlotOccupied
  if mode = #load then
    if slotOccupied then
      sprite(getProp(spriteList, #loadCar)).undefined = member("07b004v0")
    else
      sprite(getProp(spriteList, #loadCar)).undefined = member("Dummy")
    end if
  end if
  sprite(getProp(spriteList, #YesButton)).undefined = member("Dummy")
  sprite(getProp(spriteList, #NoButton)).undefined = member("Dummy")
  changedName = 0
  carSaved = 0
  exit
end

on saveIfNecessary(me)
  if changedName then
    NewName = member("SavedCarName").text
    changeCarName(gMulleGlobals.user, chosenSlot, NewName)
    if chosenSlot = currentCarSlot then
      setName(gMulleGlobals.user.car, NewName)
    end if
  end if
  if changedName then
    findFirstFree(me)
  end if
  exit
end

on replaceAsk(me)
  tempObj = new(script("ReplaceScript"))
  exit
end

on prepareEnterName(me)
  carPasted = 1
  currentCarSlot = chosenSlot
  carSaved = 1
  sendSprite(getProp(spriteList, #InsertCar), #activate, 0)
  tempSP = getProp(spriteList, #CarStart) - 1
  n = 1
  repeat while n <= 35
    sprite(tempSP + n).undefined = member("Dummy")
    n = 1 + n
  end repeat
  sprite(getProp(spriteList, #PhotoBG)).undefined = member("Dummy")
  tempSP = getProp(spriteList, #SmallCarStart) - 1
  n = 1
  repeat while n <= 35
    sprite(tempSP + n).undefined = member("Dummy")
    n = 1 + n
  end repeat
  updateStage()
  stopAllEffects(gSound)
  play(gSound, "06e001v0", #EFFECT)
  play(gSound, "06d002v0", #EFFECT)
  puppetTransition(1, 2, 5, 0)
  sendSprite(getProp(spriteList, #CarStart), #drawCar, void(), void())
  member("SavedCarName").text = ""
  sprite(getProp(spriteList, #EnterName)).undefined = 1
  setName(gMulleGlobals.user.car, "")
  saveCar(gMulleGlobals.user, chosenSlot)
  findFirstFree(me)
  sendSprite(getProp(spriteList, #SlotStart) + chosenSlot - 1, #clicked)
  exit
end

on loadCar(me, theOption)
  if voidp(theOption) then
    if slotOccupied then
      theOption = getSavedCars(gMulleGlobals.user, chosenSlot)
    else
      exit
    end if
  end if
  trash(gMulleGlobals.user.car)
  fromList(gMulleGlobals.user.car, theOption)
  -- UNK_64 0
  -- UNK_64 0
  -- UNK_64 2
  repeat while ERROR <= ERROR
    -- UNK_64 2
    -- UNK_64 1
    partId = getAt()
    if partId > 1 then
      removeJunkPart(gMulleGlobals.user, void(), partId)
    end if
  end repeat
  -- UNK_65 3
  doNextFrame = #jump
  exit
end

on keyDown(me, which)
  exit
end

on keyUp(me)
  exit
end

on mouseUp()
  exit
end

on findFirstFree(me)
  tempCars = getSavedCars(gMulleGlobals.user, #all)
  tempNrOfCars = count(tempCars)
  firstFree = 0
  tempSP = getProp(spriteList, #SlotStart) - 1
  n = 1
  repeat while n <= tempNrOfCars
    if listp(getAt(tempCars, n)) then
      sprite(n - 1).undefined = member("06n002v0" + sprite(0).number)
    else
      if not firstFree then
        firstFree = n
      end if
    end if
    n = 1 + n
  end repeat
  if mode = #save then
    if not firstFree then
      if tempNrOfCars < 12 then
        firstFree = tempNrOfCars + 1
      else
        firstFree = 1
      end if
    end if
  else
    firstFree = 1
  end if
  exit
end

on kill(me)
  if mode = #save and not the runMode = "Author" then
    save(gMulleGlobals)
  end if
  member("SavedCarName").text = " "
  member("SavedCarName").editable = 0
  fileObject = 0
  if objectp(introObject) then
    introObject = kill(introObject)
  end if
  ancestor = kill(ancestor)
  closeWindow(me)
  play(gSound, "06e003v0", #EFFECT)
  return(0)
  exit
end

on openWindow(me)
  cursor(-1)
  activateScreen(me, 0)
  savedCarFiles = checkFolder(fileObject)
  myMIAW = window("Choose")
  tempSize = point(336, 278)
  tempLoc = point(300, 220)
  tempLoc = tempLoc - tempSize / 2
  tempLoc = tempLoc + point(the stageLeft, the stageTop)
  tempRect = rect(getAt(tempLoc, 1), getAt(tempLoc, 2), getAt(tempLoc, 1) + getAt(tempSize, 1), getAt(tempLoc, 2) + getAt(tempSize, 2))
  myMIAW.rect = tempRect
  myMIAW.fileName = "13"
  myMIAW.titleVisible = 0
  open(myMIAW)
  cursor(200)
  exit
end

on closeWindow(me)
  if not myMIAW = 0 then
    -- UNK_63 130
    close(myMIAW)
    myMIAW = 0
  end if
  doNextFrame = #activateScreen
  exit
end

on activateScreen(me, YesNo)
  tempSP = getProp(spriteList, #SlotStart)
  n = 1
  repeat while n <= 12
    sendSprite(tempSP + n - 1, #activate, YesNo)
    n = 1 + n
  end repeat
  if YesNo = 0 or YesNo and mode = #save and carPasted = 0 then
    sendSprite(getProp(spriteList, #InsertCar), #activate, YesNo)
    sendSprite(getProp(spriteList, #PhotoBG), #activate, YesNo)
  end if
  sendSprite(getProp(spriteList, #DialogueButton), #activate, YesNo)
  sendSprite(getProp(spriteList, #GoBack), #activate, YesNo)
  exit
end

on dialogueResult(me, what, theFile)
  if what = #ChoseFile then
    if mode = #load then
      tempList = loadCar(fileObject, theFile)
      if listp(tempList) then
        closeWindow(me)
        loadCar(me, tempList)
        exit
      else
        if stringp(tempList) then
          closeWindow(me)
          alert(tempList)
        end if
      end if
    else
      saveCar(fileObject, theFile)
      closeWindow(me)
    end if
  else
    if what = #NewFile then
      saveCar(fileObject, theFile)
      closeWindow(me)
    else
      if what = #Cancel then
        closeWindow(me)
      end if
    end if
  end if
  exit
end