on beginSprite(me)
  SP = me.spriteNum
  childSprites = [1]
  exit
end

on init(me, theMasterSP)
  masterSP = theMasterSP
  exit
end

on SetChildren(me, theList)
  childSprites = duplicate(theList)
  tempRect = sprite(getAt(childSprites, 1)).undefined
  limits = [getAt(tempRect, 2), getAt(tempRect, 4)]
  topLimit = getAt(tempRect, 2)
  mySpace = getAt(tempRect, 4) - getAt(tempRect, 2)
  regPointPercent = 100 * getAt(sprite(SP).undefined.regPoint, 2) / getAt(sprite(SP).undefined.rect, 4)
  exit
end

on mouseDown(me)
  mouseOnMe = 1
  if ScrollBHType = #ScrollerMid then
    grabbedOffset = the mouseV - sprite(SP).locV
  else
    if ScrollBHType = #ScrollerBehind then
      tempMouse = the mouseV
      tempScroll = 0
      if tempMouse < myTop then
        tempScroll = -1
      else
        if tempMouse > myTop + myHeight then
          tempScroll = 1
        end if
      end if
      sendSprite(masterSP, #scroll, #Page, tempScroll)
    else
      if ScrollBHType = #ArrowUp or ScrollBHType = #ArrowDown then
        waitFrames = 0
        exitFrame(me)
        waitFrames = 3
      end if
    end if
  end if
  exit
end

on mouseUp(me)
  mouseOnMe = 0
  exit
end

on mouseUpOutSide(me)
  mouseOnMe = 0
  exit
end

on setScrollInfo(me, thePercentDown, thePercentFilled)
  if ScrollBHType = #ScrollerMid then
    if midStretch then
      if integerp(thePercentFilled) then
        myHeight = mySpace * thePercentFilled / 100
        if myHeight < 20 then
          myHeight = 20
        end if
        sprite(SP).height = myHeight
        tempRect = sprite(SP).undefined
        regTopOffset = myHeight * regPointPercent / 100
      end if
      tempDown = thePercentDown * mySpace - myHeight / 100
      myTop = topLimit + tempDown
      sprite(SP).locV = myTop + regTopOffset
      setScrollEnds(me)
    else
      tempDown = thePercentDown * mySpace / 100
      myTop = topLimit + tempDown
      sprite(SP).locV = myTop
    end if
  else
    if ScrollBHType = #ScrollerBehind then
      myTop = thePercentDown
      myHeight = thePercentFilled
    end if
  end if
  exit
end

on setScrollEnds(me)
  if getAt(childSprites, 2) > 0 then
    sprite(getAt(childSprites, 2)).locV = myTop
    sprite(getAt(childSprites, 3)).locV = myTop + myHeight
  end if
  sendSprite(getAt(childSprites, 1), #setScrollInfo, myTop, myHeight)
  exit
end

on exitFrame(me)
  if ScrollBHType = #ScrollerMid then
    if mouseOnMe then
      if midStretch then
        goFor = the mouseV - grabbedOffset
        if goFor < regTopOffset + topLimit then
          tempLocV = regTopOffset + topLimit
        else
          if goFor > regTopOffset + topLimit + mySpace - myHeight then
            tempLocV = regTopOffset + topLimit + mySpace - myHeight
          else
            tempLocV = goFor
          end if
        end if
        sprite(SP).locV = tempLocV
        myTop = tempLocV - regTopOffset
        tempMaxDown = mySpace - myHeight
        if tempMaxDown = 0 then
          tempMaxDown = 1
        end if
        sendSprite(masterSP, #scroll, #percent, 100 * myTop - topLimit / tempMaxDown)
        setScrollEnds(me)
      else
        goFor = the mouseV - grabbedOffset
        if goFor < topLimit then
          tempLocV = topLimit
        else
          if goFor > topLimit + mySpace then
            tempLocV = topLimit + mySpace
          else
            tempLocV = goFor
          end if
        end if
        sprite(SP).locV = tempLocV
        myTop = tempLocV
        tempMaxDown = mySpace
        if tempMaxDown = 0 then
          tempMaxDown = 1
        end if
        sendSprite(masterSP, #scroll, #percent, 100 * myTop - topLimit / tempMaxDown)
        setScrollEnds(me)
      end if
    end if
  else
    if ScrollBHType = #ArrowUp or ScrollBHType = #ArrowDown then
      if mouseOnMe then
        if waitFrames then
          waitFrames = waitFrames - 1
        else
          if ScrollBHType = #ArrowUp then
            sendSprite(masterSP, #scroll, #Relative, -1)
          else
            sendSprite(masterSP, #scroll, #Relative, 1)
          end if
        end if
      end if
    end if
  end if
  exit
end

on getPropertyDescriptionList(me)
  p_list = [#ScrollBHType:[#comment:"This sprite is:", #format:#symbol, #range:[#ArrowUp, #ArrowDown, #ScrollerUp, #ScrollerMid, #ScrollerDown, #ScrollerBehind], #default:#ArrowUp], #midStretch:[#comment:"Stretch scrollbar:", #format:#boolean, #default:1]]
  return(p_list)
  exit
end