on new(me, theChild)
  child = theChild
  insideInner = 0
  return(me)
  exit
end

on kill(me)
  child = 0
  return(0)
  exit
end

on init(me)
  nrOfLetters = 6
  racing = 0
  delayCounter = 0
  fps = the frameTempo
  nrOfTimesPassed = 0
  mustEnterFrom = getaProp(child.optionalData, #EnterDir)
  if voidp(mustEnterFrom) then
    mustEnterFrom = 1
  end if
  saveName = "CustomRacingDB"
  fieldName = "CustomRacingField"
  if sprite(0).number = -1 then
    newMember(#field, saveName, "data")
    hiScores = [186:"MIA M", 232:"FIGGE F"]
    member(saveName).text = string(hiScores)
    if the machineType = 256 then
      tempFont = "Arial"
      tempSize = 20
    else
      tempFont = "Helvetica"
      tempSize = 24
    end if
    n = 1
    repeat while n <= 2
      newMember(#field, fieldName & string(n), "data")
      member(fieldName & string(n)).boxType = #fixed
      sprite(0).undefined = tempFont
      sprite(0).undefined = tempSize
      member(fieldName & string(n)).text = " "
      sprite(0).undefined = tempFont
      sprite(0).undefined = tempSize
      member(fieldName & string(n)).rect = rect(0, 0, 158, 20)
      sprite(0).foreColor = 149
      n = 1 + n
    end repeat
    exit repeat
  end if
  hiScores = value(member(saveName).text)
  sort(hiScores)
  tempSP = child.SPUnder
  sprite(tempSP).name = member(getAt(getProp(getFrameList(child), #Board), 1))
  tempLoc = getaProp(child.optionalData, #Board)
  if voidp(tempLoc) then
    tempLoc = point(0, 0)
  end if
  sprite(tempSP).position = tempLoc
  sprite(tempSP + 1).name = member(getAt(getProp(getFrameList(child), #Goal), 1))
  sprite(tempSP + 1).position = child.myLoc
  showTime(me)
  n = 1
  repeat while n <= 2
    sprite(tempSP + n + 1).name = member(fieldName & string(n))
    sprite(tempSP + n + 1).position = getaProp(child.optionalData, #Board) + point(-75, -25) + point(0, 30) * n - 1
    n = 1 + n
  end repeat
  exit
end

on step(me, carLoc)
  temp = checkRadius(gDir.drivingHandlers, me, carLoc, child.myLoc, #Inner)
  if temp = #EnterInnerRadius then
    EnterInnerRadius(me, carLoc)
  else
    if temp = #ExitInnerRadius then
      ExitInnerRadius(me, carLoc)
    end if
  end if
  if racing then
    counter = counter + 1
    member(fieldName & "1").text = string(counter / fps) & ":" & string(10 * counter mod fps / fps) & "0"
  else
    if delayCounter then
      delayCounter = delayCounter - 1
      if delayCounter mod 6 = 5 then
        member(fieldName & "1").text = thisTime
      else
        if delayCounter mod 6 = 0 then
          member(fieldName & "1").text = " "
        end if
      end if
      if delayCounter = 0 then
        showTime(me)
      end if
    end if
  end if
  exit
end

on showTime(me)
  n = 1
  repeat while n <= 2
    tempTime = string(getPropAt(hiScores, n) / 10) & ":" & string(getPropAt(hiScores, n) mod 10) & "0"
    member(fieldName & string(n)).text = tempTime && getAt(hiScores, n).char[1..nrOfLetters]
    n = 1 + n
  end repeat
  exit
end

on enterOuterRadius(me)
  exit
end

on ExitOuterRadius(me)
  exit
end

on EnterInnerRadius(me, carLoc)
  tempEnterAngl = calcDirection(gDir.drivingHandlers, carLoc, child.myLoc)
  tempDiff = abs(mustEnterFrom - tempEnterAngl)
  if tempDiff > 8 then
    tempDiff = 16 - tempDiff
  end if
  if tempDiff <= 3 then
    enteredFrom = 1
    if racing then
      if nrOfTimesPassed = 1 then
        play(gSound, getAt(child.sounds, 2), #EFFECT)
        addCompletedMission(gMulleGlobals.user, getAt(getSetWhenDone(child, #missions), 1))
        racing = 0
        delayCounter = 24
        tempTime = 10 * counter / fps
        -- UNK_46 154
        tempName = ERROR
        thisTime = string(tempTime / 10) & ":" & string(tempTime mod 10) & "0" && tempName.char[1..nrOfLetters]
        setCacheProp(gMulleGlobals.user.car, #racing, tempTime)
        if tempTime < 150 then
          medalId = getAt(getSetWhenDone(child, #medals), 1)
          if not getMedal(gMulleGlobals.user.car, medalId) then
            sendSprite(getProp(gDir.spriteList, #medal), #Blink, medalId)
            addMedal(gMulleGlobals.user.car, medalId)
          end if
        end if
        if getPropAt(hiScores, count(hiScores)) >= tempTime then
          deleteAt(hiScores, count(hiScores))
          addProp(hiScores, tempTime, tempName.char[1..nrOfLetters])
          member(saveName).text = string(hiScores)
        end if
      end if
    else
      play(gSound, getAt(child.sounds, 1), #EFFECT)
      nrOfTimesPassed = 0
      racing = 1
      counter = 0
      n = 1
      repeat while n <= 2
        member(fieldName & string(n)).text = " "
        n = 1 + n
      end repeat
    end if
    exit repeat
  end if
  enteredFrom = -1
  exit
end

on ExitInnerRadius(me, carLoc)
  if racing then
    tempEnterAngl = calcDirection(gDir.drivingHandlers, carLoc, child.myLoc)
    tempDiff = abs(mustEnterFrom - tempEnterAngl)
    if tempDiff > 8 then
      tempDiff = 16 - tempDiff
    end if
    if tempDiff <= 3 then
      if enteredFrom = -1 then
        nrOfTimesPassed = nrOfTimesPassed - 1
      end if
    else
      if enteredFrom = 1 then
        nrOfTimesPassed = nrOfTimesPassed + 1
      end if
    end if
  end if
  exit
end